      PROGRAM X333SCR
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS CONVERTS THE SCRATCH FILES OF AN X333 JOB INTO ASCII CODE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVSIZ,CS,DETSIZ,E,FFIJN
      INTEGER I,J,K,MAT,MF,MT,N1,NEC1,NEIN,NER1,NGUSER,NR
      CHARACTER*72 USERINP
      CHARACTER*8 NAME
      CHARACTER*2 CNAM
      DIMENSION COVSIZ(2),CS(640),E(641),FFIJN(NLIMAX),DETSIZ(2)
      EQUIVALENCE (E(1),CS(1))
      OPEN (UNIT=1,FILE='X333SCR.LOG',STATUS='UNKNOWN',
     1   FORM='FORMATTED')
C-=-=-
C     X333.SC1
C-=-=-
      WRITE (*,*)
     1   'NUMBER OF THE ENERGY GROUPS IN THE USER''S STRUCTURE ? '
      READ (*,*) NGUSER
      WRITE (1,80) NGUSER
      OPEN (UNIT=9,FILE='X333.SC1',STATUS='OLD',FORM='UNFORMATTED',
     1   ERR=9)
    2 READ (9,END=9,ERR=9) NAME,MAT,MT,DETSIZ,CNAM,COVSIZ,ANIS,N1
      WRITE (1,81) NAME,MAT,MT,DETSIZ,CNAM,COVSIZ,ANIS
      READ (9,END=9,ERR=9) (CS(I),I=N1,640)
      WRITE (1,82) (I,CS(I),I=N1,640)
      READ (9,END=9,ERR=9) N1,(CS(I),I=1,NGUSER)
      WRITE (1,83) (I,CS(I),I=N1,NGUSER)
      GO TO 2
    9 CLOSE (UNIT=9,STATUS='KEEP',ERR=10)
C-=-=-
C     X333.SC2
C-=-=-
   10 OPEN (UNIT=10,FILE='X333.SC2',STATUS='OLD',FORM='UNFORMATTED',
     1   ERR=19)
      WRITE (1,84)
   11 READ (10,END=19,ERR=19) NR,MAT,MF,MT
      WRITE (1,85) NR,MAT,MF,MT
      GO TO 11
   19 CLOSE (UNIT=10,STATUS='KEEP',ERR=20)
C-=-=-
C     X333.SC3
C-=-=-
   20 OPEN (UNIT=11,FILE='X333.SC3',STATUS='OLD',FORM='FORMATTED',
     1   ERR=29)
      WRITE (1,86)
   21 READ (11,87,END=29,ERR=29) USERINP
      WRITE (1,87) USERINP
      GO TO 21
   29 CLOSE (UNIT=11,STATUS='KEEP',ERR=30)
C-=-=-
C     X333.SC4
C-=-=-
   30 OPEN (UNIT=12,FILE='X333.SC4',STATUS='OLD',FORM='UNFORMATTED',
     1   ERR=39)
      WRITE (1,88)
      DO 31 J=1,2
         READ (12,END=39,ERR=39) I,NAME,DETSIZ,CNAM,COVSIZ,ANIS
         WRITE (1,89) I,NAME,DETSIZ,CNAM,COVSIZ,ANIS
   31 CONTINUE
      READ (12,END=39,ERR=39) NER1,NEC1
      NEIN=NER1+NEC1+2
      READ (12,END=39,ERR=39) (E(K),K=1,NEIN)
      WRITE (1,90) NER1,NEC1,(E(K),K=1,NEIN)
      WRITE (1,91)
      DO 35 J=1,NER1
         READ (12,END=39,ERR=39) (FFIJN(K),K=1,NEC1)
         WRITE (1,92) J,(FFIJN(K),K=1,NEC1)
   35 CONTINUE
   39 CLOSE (UNIT=12,STATUS='KEEP',ERR=66)
C-=-=-
   66 STOP
C-=-=-
   80 FORMAT (''/'X333.SC1'//'Number of user''s energy groups =',I4)
   81 FORMAT ('Detector name = "',A,'"'/'MAT, MT = ',2I5/
     1   'Detector size = ',1P,2E10.3/
     2   'Cover = "',A,'"'/'Cover size = ',1P,2E10.3/
     3   'Anisotropy = ',0PF8.2)
   82 FORMAT ('Cross sections/cover shielding factors',
     1   ' in the SAND II structure:'/(5(I4,1P,E11.4)))
   83 FORMAT ('Cross sections/cover shielding factors',
     1   ' in the user''s structure:'/(5(I4,1P,E11.4)))
   84 FORMAT (''/'X333.SC2'//'NR      MAT MF  MT'//)
   85 FORMAT (I6,I5,I3,I4)
   86 FORMAT (''/'X333.SC3'//'User''s input without card numbers'//)
   87 FORMAT (A)
   88 FORMAT (''/'X333.SC4'//
     1   'Cross section covariance data (master library)'/)
   89 FORMAT ('User''s request No:',I4/'Detector name = "',A,'"'/
     1   'Detector size = ',1P,2E10.3/
     2   'Cover = "',A,'"'/'Cover size = ',1P,2E10.3/
     3   'Anisotropy = ',0PF8.2)
   90 FORMAT (/'The size of the table:',I4,' *',I4/
     1   'Energy grid:'/(1P,8E10.3))
   91 FORMAT (/'Covariance data:')
   92 FORMAT (I5/(1P,8E10.3))
      END
