      SUBROUTINE CALCUF
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE GROUP FLUXES IN THE USER'S
C     ENERGY STRUCTURE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL CMUSER,CRUSER,EMAX,EMIN,ESAND,EUSER,FLSAND,FRAC,WI,WORKS
      INTEGER I,J,NGUSER
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WORKS(641)
      SAVE
      DO 2 I=1,NGUSER
      FLUSER(I)=0.D0
      DO 1 J=1,640
      IF (ESAND(J).GE.EUSER(I+1)) GO TO 2
      IF (ESAND(J+1).LE.EUSER(I)) GO TO 1
      EMIN=AMAX1(ESAND(J),EUSER(I))
      EMAX=AMIN1(ESAND(J+1),EUSER(I+1))
      FRAC=(EMAX-EMIN)/(ESAND(J+1)-ESAND(J))
      FLUSER(I)=FLUSER(I)+FRAC*FLSAND(J)
    1 CONTINUE
    2 CONTINUE
      RETURN
      END
      SUBROUTINE CNCTIO(INF,PRD,L613,TITCRD,NR,NG,EXDIR,EXXSL,
     1   L4,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONNECTS THE I/O FILES TO THE LOGICAL UNITS.
C     FOR BATCH PROCESSING COMMENT OUT THE STATEMENTS BETWEEN THE
C     "INTERACTIVE" MARKS.
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,I333,IER,IWORK,L,L4,L613,L78,LDSC,LFIL,LLIBN,LTSKN,
     1   LWSPN,MAT,MAT0,MF,MF0,MT,MT0,NG,NGL,NR,NS
      REAL ESAND,FLSAND,WI,WJ,WSP
      CHARACTER*84 FIL2,FIL3,FIL4,FIL6,FIL7,FIL8,DSC,SPECID
      CHARACTER*80 FILSP,LIBNAM,TITCRD,TSKNAME,WSPNAME
      CHARACTER*66 CH66
      CHARACTER*3 CHNGUS
      CHARACTER*1 CHIN,O,OO
      LOGICAL BUO,EX,EXDIR,EXULIB,EXXSL,INF,PRD
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      DIMENSION WSP(640)
      SAVE
    1 FORMAT (A)
C***** IBM PC/AT DOS *****
    2 FORMAT (/1X,A/' IS NOT IN THE CURRENT DIRECTORY.')
    3 FORMAT (/1X,A/' EXISTS IN THE CURRENT DIRECTORY.')
    4 FORMAT (' TYPE THE FILE-SPEC ([DRIVE:][PATH]FILENAME.EXTENSION):'
     1   /)
    5 FORMAT (/' TYPE [DRIVE:][PATH\] FOR THE SCRATCH FILES:'/)
C***** IBM PC/AT DOS *****
    6 FORMAT (I3)
      PRD=.FALSE.
      L613=13
C-=-=-
C     CROSS SECTION LIBRARIES IN FINE GROUP STRUCTURE
C-=-=-
   10 CONTINUE
C***** INTERACTIVE RUN *****
      WRITE (0,11)
C***** INTERACTIVE RUN *****
   11 FORMAT (/' NAME OF THE MASTER CROSS SECTION LIBRARY (ENDF-6):'/
     1   ' ([D:] [PATH] FILENAME)'/)
      READ (5,1) LIBNAM
      CALL LASTCH(LIBNAM,LLIBN)
      IF (LLIBN.EQ.0) GO TO 10
      FIL3=LIBNAM(1:LLIBN)//'.DAT'
      L=LLIBN+4
      INQUIRE (FILE=FIL3,EXIST=EX)
      IF (.NOT.EX) THEN
   12    CONTINUE
C***** INTERACTIVE RUN *****
         WRITE (0,2) FIL3(1:L)
         WRITE (0,4)
C***** INTERACTIVE RUN *****
         READ (5,1) FILSP
         FIL3=FILSP
         CALL LASTCH(FIL3,LFIL)
         IF (LFIL.EQ.0) GO TO 12
         INQUIRE(FILE=FIL3,EXIST=EX)
         IF (.NOT.EX) GO TO 60
      END IF
C***** LAHEY F77L3 4.01 *****
       OPEN (UNIT=3,FILE=FIL3,ACCESS='DIRECT',BLANK='ZERO',
     1     RECL=82,FORM='FORMATTED',STATUS='OLD')
C***** LAHEY F77L3 4.01 *****
C***** IBM RISC/6000 AIX *****
C     OPEN (UNIT=3,FILE=FIL3,ACCESS='DIRECT',BLANK='ZERO',
C    1     RECL=81,FORM='FORMATTED',STATUS='OLD')
C***** IBM RISC/6000 AIX *****
C***** RYAN-McFARLAND 1.00, 2.42; MICROSOFT 5.00 *****
C     OPEN (UNIT=3,FILE=FIL3,ACCESS='DIRECT',BLANK='ZERO',
C    1     RECL=80,FORM='FORMATTED',STATUS='OLD')
C***** RYAN-McFARLAND 1.00, 2.42; MICROSOFT 5.00 *****
      READ (3,13,REC=1) CH66
   13 FORMAT (A66)
C-=-=-
C     USER'S INPUT
C-=-=-
   20 CONTINUE
C***** INTERACTIVE RUN *****
      WRITE (0,21)
C***** INTERACTIVE RUN *****
   21 FORMAT (/' NAME OF THE TASK: '/)
      READ (5,1) TSKNAME
      CALL LASTCH(TSKNAME,LTSKN)
      IF (LTSKN.EQ.0) GO TO 20
      FIL8=TSKNAME(1:LTSKN)//'.DAT'
      L=LTSKN+4
      INQUIRE (FILE=FIL8,EXIST=EX)
      IF (.NOT.EX) THEN
   32    CONTINUE
C***** INTERACTIVE RUN *****
         WRITE (0,2) FIL8(1:L)
         WRITE (0,4)
C***** INTERACTIVE RUN *****
         READ (5,1) FILSP
         FIL8=FILSP
         CALL LASTCH(FIL8,LFIL)
         IF (LFIL.EQ.0) GO TO 32
         INQUIRE(FILE=FIL8,EXIST=EX)
         IF (.NOT.EX) GO TO 60
      END IF
C-=-=-
C     CROSS SECTION LIBRARY IN THE USER'S (COARSE) GROUP STRUCTURE
C-=-=-
      FIL4=TSKNAME(1:LTSKN)//'.XSL'
      L=LTSKN+4
      INQUIRE (FILE=FIL4,EXIST=EXULIB)
      IF (EXULIB) THEN
C***** RYAN-McFARLAND 1.00, 2.42; MICROSOFT 5.00 ; LAHEY F77L3 4.01 *****
         OPEN (UNIT=4,FILE=FIL4,STATUS='OLD',ACCESS='DIRECT',
     1   RECL=1,FORM='UNFORMATTED',ERR=67)
C***** RYAN-McFARLAND 1.00, 2.42; MICROSOFT 5.00 ; LAHEY F77L3 4.01 *****
C***** INTERACTIVE RUN *****
         WRITE (0,3) FIL4(1:L)
   33    WRITE (0,37)
C***** INTERACTIVE RUN *****
C***** BATCH PROCESSING *****
C  33    CONTINUE
C***** BATCH PROCESSING *****
         READ (5,1) O
         IF (O.EQ.'D'.OR.O.EQ.'d') THEN
            READ (4,REC=1,ERR=34) OO
   34       CLOSE (UNIT=4,STATUS='DELETE')
            EXXSL=.FALSE.
         ELSE IF (O.EQ.'N'.OR.O.EQ.'n') THEN
   35       CONTINUE
C***** INTERACTIVE RUN *****
            WRITE (0,4)
C***** INTERACTIVE RUN *****
            READ (5,1) FILSP
            FIL4=FILSP
            CALL LASTCH(FIL4,LFIL)
            IF (LFIL.EQ.0) GO TO 35
            INQUIRE(FILE=FIL4,EXIST=EXULIB)
            IF (EXULIB) GO TO 62
            EXXSL=.FALSE.
         ELSE IF (O.EQ.'U'.OR.O.EQ.'u') THEN
            EXXSL=.TRUE.
         ELSE
            GO TO 33
         END IF
      ELSE
         EXXSL=.FALSE.
      END IF
   37 FORMAT (/' HOW TO CONTINUE ? {D|U|N}'/
     1  '    ENTER "D" FOR DELETING THE OLD VERSION'/
     2  '    ENTER "U" FOR UPDATING THE OLD VERSION'/
     3  '    ENTER "N" FOR SELECTING A NEW NAME '/)
C-=-=-
C     PRINTABLE OUTPUT
C-=-=-
   38 CONTINUE
C***** INTERACTIVE RUN *****
      WRITE (0,39)
C***** INTERACTIVE RUN *****
   39 FORMAT (/' SELECT THE STANDARD OUTPUT {S|P|D}:'/
     1  '    ENTER "S" FOR THE SCREEN'/
     2  '    ENTER "P" FOR THE PRINTER'/
     3  '    ENTER "D" FOR THE DISK FILE TASK_NAME.PRN'/)
      READ (5,1) O
      IF (O.EQ.'P' .OR. O.EQ.'p' .OR. O.EQ.'D' .OR. O.EQ.'d') THEN
         INF=.TRUE.
   40    CONTINUE
C***** INTERACTIVE RUN *****
         WRITE (0,41)
C***** INTERACTIVE RUN *****
   41    FORMAT (/' DO YOU WANT TO GET DEBUGGING INFORMATION {Y|N} ? '/)
         READ (5,1) OO
         IF (OO.EQ.'N' .OR. OO.EQ.'n') THEN
            L613=13
         ELSE IF (OO.EQ.'Y' .OR. OO.EQ.'y') THEN
            L613=6
         ELSE
            GO TO 40
         END IF
      END IF
      IF (O.EQ.'P' .OR. O.EQ.'p') THEN
         OPEN (UNIT=6,FILE='PRN')
         WRITE (0,*)
     1      'PUT WIDE PAPER INTO PRINTER OR SET "CONDENSED" MODE'
         WRITE (0,*) 'HIT ENTER WHEN READY'
         READ (5,*)
      ELSE IF (O.EQ.'D' .OR. O.EQ.'d') THEN
         FIL6=TSKNAME(1:LTSKN)//'.PRN'
         INQUIRE (FILE=FIL6,EXIST=EX)
         IF (EX) THEN
   42       CONTINUE
C***** INTERACTIVE RUN *****
            WRITE (0,3) FIL6(1:L)
   43       WRITE (0,44)
C***** INTERACTIVE RUN *****
C***** BATCH PROCESSING *****
C  43       CONTINUE
C***** BATCH PROCESSING *****
            READ (5,1) O
            IF (O.EQ.'N' .OR. O.EQ.'n') THEN
C***** INTERACTIVE RUN *****
               WRITE (0,4)
C***** INTERACTIVE RUN *****
               READ (5,1) FILSP
               FIL6=FILSP
               CALL LASTCH(FIL6,LFIL)
               IF (LFIL.EQ.0) GO TO 42
               INQUIRE(FILE=FIL6,EXIST=EX)
               IF (EX) THEN
                  GO TO 62
               ELSE
                  PRD=.TRUE.
                  OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
               END IF
            ELSE IF (O.EQ.'D' .OR. O.EQ.'d') THEN
               PRD=.TRUE.
               OPEN (UNIT=6,FILE=FIL6,STATUS='OLD')
            ELSE
               GO TO 43
            END IF
         ELSE
            PRD=.TRUE.
            OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
         END IF
      ELSE IF (O.EQ.'S' .OR. O.EQ.'s') THEN
         INF=.FALSE.
      ELSE
         GO TO 38
      END IF
   44 FORMAT (/' HOW TO CONTINUE ? {D|N}'/
     1  '    ENTER "D" FOR DELETING THE OLD VERSION'/
     2  '    ENTER "N" FOR SELECTING A NEW NAME '/)
C-=-=-
C     SCRATCH FILES
C-=-=-
C***** INTERACTIVE RUN *****
      WRITE (0,5)
C***** INTERACTIVE RUN *****
      READ (5,1) DSC
      CALL LASTCH(DSC,LDSC)
      FILSP=DSC(1:LDSC)//'X333'
      L=LDSC+4
      DSC=FILSP(1:L)//'.SC1'
      OPEN (UNIT=9,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      END FILE (9)
      REWIND (9)
      DSC=FILSP(1:L)//'.SC2'
      OPEN (UNIT=10,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      END FILE (10)
      REWIND (10)
      DSC=FILSP(1:L)//'.SC3'
      OPEN (UNIT=11,FILE=DSC,STATUS='UNKNOWN',FORM='FORMATTED',
     1   BLANK='ZERO')
      END FILE (11)
      REWIND (11)
      DSC=FILSP(1:L)//'.SC4'
      OPEN (UNIT=12,FILE=DSC,STATUS='UNKNOWN',FORM='UNFORMATTED')
      END FILE (12)
      REWIND (12)
      OPEN (UNIT=13,FILE='NUL')
C-=-=-
C     IS THE USER'S INPUT CARD NUMBERED?
C-=-=-
      OPEN (UNIT=8,FILE=FIL8,STATUS='OLD')
      CALL NOCOMM(.FALSE.,8,L78)
      READ (L78,1) TITCRD
      READ (L78,*) NR,NG
C-=-=-
C     CROSS SECTION LIBRARY IN THE USER'S STRUCTURE
C-=-=-
      L4=MAX((NG+1)*4,46)
      IF (EXXSL) THEN
         DO 45 I=1,3
         READ (4,REC=I) CHIN
         CHNGUS(I:I)=CHIN
   45    CONTINUE
         READ (CHNGUS,6) NGL
         CLOSE (UNIT=4,STATUS='KEEP')
C***** RYAN-McFARLAND 1.00, 2.42; MICROSOFT 5.00 ; LAHEY F77L3 4.01 *****
         IF (NGL.NE.NG) GO TO 64
      END IF
      OPEN (UNIT=4,FILE=FIL4,ACCESS='DIRECT',
     1      RECL=L4,FORM='UNFORMATTED',STATUS='UNKNOWN',ERR=66)
C-=-=-
C     DIRECTORY OF THE MASTER CROSS SECTION LIBRARY
C-=-=-
      FIL2=LIBNAM(1:LLIBN)//'.FCD'
      INQUIRE (FILE=FIL2,EXIST=EXDIR)
      IF (.NOT.EXDIR) THEN
         FIL2=LIBNAM(1:LLIBN)//'.DIR'
         INQUIRE (FILE=FIL2,EXIST=EXDIR)
      END IF
      IF (EXDIR) THEN
         OPEN (UNIT=2,FILE=FIL2,STATUS='OLD',FORM='FORMATTED',
     1        BLANK='ZERO')
      ELSE
         OPEN (UNIT=2,FILE=FIL2,FORM='FORMATTED',
     1        STATUS='NEW',ACCESS='SEQUENTIAL')
         I333=2
         MAT0=0
         MF0=0
         MT0=0
   46    READ (3,48,REC=I333) CH66,MAT,MF,MT,IWORK
         IF (MAT.LT.0) GO TO 47
         IF (MAT.NE.MAT0 .OR. MF.NE.MF0 .OR. MT.NE.MT0) THEN
            IF (MT.NE.0) WRITE (2,49) I333,MAT,MF,MT
            MAT0=MAT
            MF0=MF
            MT0=MT
         END IF
         I333=I333+1
         GO TO 46
   47    END FILE (2)
         REWIND (2)
      END IF
   48 FORMAT (A66,I4,I2,I3,I5)
   49 FORMAT (I6,I5,I3,I4)
   50 READ (2,49,END=55) NS,MAT,MF,MT
      WRITE (10) NS,MAT,MF,MT
      GO TO 50
   55 END FILE (10)
      REWIND (10)
      RETURN
C-=-=-
C     RETURN ON ERROR
C-=-=-
   60 IER=41
C***** INTERACTIVE RUN *****
      WRITE (0,61) FILSP(1:L)
C***** INTERACTIVE RUN *****
   61 FORMAT (/1X,A/' DOES NOT EXIST.'//' ??? 41 ??? SORRY.'//)
      GO TO 69
   62 IER=42
C***** INTERACTIVE RUN *****
      WRITE (0,63) FILSP(1:L)
C***** INTERACTIVE RUN *****
   63 FORMAT (/1X,A/' ALREADY EXISTS.'//' ??? 42 ??? SORRY.'//)
      GO TO 69
   64 IER=43
C***** INTERACTIVE RUN *****
      WRITE (0,65) NG
C***** INTERACTIVE RUN *****
   65 FORMAT (' ??? 43 ???',
     1   '  INCOMPATIBLE LIBRARY: REQUESTED GROUP STRUCTURE:',I4/
     2   '  THE SELECTED LIBRARY HAS BEEN GENERATED USING:',I6,
     3   '  GROUP STRUCTURE (FATAL ERROR)')
      GO TO 69
   66 IER=44
C***** INTERACTIVE RUN *****
   67 WRITE (0,68) FIL4
C***** INTERACTIVE RUN *****
   68 FORMAT (' ??? 44 ???   FATAL DOS ERROR PROCESSING THE FILE: ',A)
   69 CALL ERRLOG(IER)
      RETURN
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY CNNWSP(SPECID,WSP,IER,BUO)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     IF THE USER'S INPUT DOES NOT CONTAIN THE WEIGHTING SPECTRUM,
C     READ IT FROM SEPARATE FILE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      FIL7=TSKNAME(1:LTSKN)//'.WSP'
      INQUIRE (FILE=FIL7,EXIST=EX)
      BUO=.FALSE.
      IF (.NOT.EX) THEN
         FIL7=TSKNAME(1:LTSKN)//'.BUO'
         INQUIRE (FILE=FIL7,EXIST=EX)
         BUO=EX
      END IF
      IF (EX) THEN
         OPEN (UNIT=7,FILE=FIL7,STATUS='OLD',FORM='FORMATTED',
     1        BLANK='ZERO')
      ELSE
   70    CONTINUE
C***** INTERACTIVE RUN *****
         WRITE (0,71)
C***** INTERACTIVE RUN *****
   71    FORMAT (/' TYPE [D:] [PATH] FILENAME.EXTENSION FOR THE',
     1            ' 640 GROUP WEIGHTING SPECTRUM:'/)
         READ (5,1) WSPNAME
         CALL LASTCH(WSPNAME,LWSPN)
         IF (LWSPN.EQ.0) GO TO 70
         INQUIRE (FILE=WSPNAME,EXIST=EX)
         IF (.NOT.EX) THEN
   72       CONTINUE
C***** INTERACTIVE RUN *****
            WRITE (0,2) WSPNAME(1:L)
            WRITE (0,4)
C***** INTERACTIVE RUN *****
            READ (5,1) WSPNAME
            CALL LASTCH(WSPNAME,LWSPN)
            IF (LWSPN.EQ.0) GO TO 72
            INQUIRE(FILE=WSPNAME,EXIST=EX)
            IF (.NOT.EX) THEN
               IF (EXDIR) CLOSE (UNIT=2,STATUS='KEEP')
               CLOSE (UNIT=3, STATUS='KEEP')
               CLOSE (UNIT=4 ,STATUS='DELETE')
               CLOSE (UNIT=8,STATUS='KEEP')
               CLOSE (UNIT=9,STATUS='DELETE')
               GO TO 60
            END IF
         END IF
         OPEN (UNIT=7,FILE=WSPNAME,STATUS='OLD',FORM='FORMATTED',
     1        BLANK='ZERO')
      END IF
      CALL NOCOMM(BUO,7,L78)
      READ (L78,1) SPECID
      IF (BUO) THEN
         DO 75 I=2,114
         READ (L78,1)
   75    CONTINUE
      END IF
      READ (L78,*,ERR=76,END=76) WSP
      CLOSE (UNIT=L78,STATUS='KEEP')
      RETURN
   76 CONTINUE
C***** INTERACTIVE RUN *****
      WRITE (0,77) WSPNAME
C***** INTERACTIVE RUN *****
   77 FORMAT (' ??? 44 ???'/A/'READ ERROR'//' SORRY')
      IER=44
      CALL ERRLOG(IER)
      RETURN
      END
      SUBROUTINE COARXS(LPT,NFIRST,ILOW,ISS)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE CROSS SECTIONS IN THE USER'S
C     COARSE GRID
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL CMUSER,CRUSER,EMAX,EMIN,ESAND,EUSER,FLSAND,FRAC,WI,WJ
      INTEGER I,ILOW,ISS,J,NFIRST,NGUSER
      LOGICAL LPT,JLOW
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      SAVE
      IF (ISS.EQ.0) THEN
         BACKSPACE (9)
         READ (9) (WI(I),I=NFIRST,640)
         DO 10 I=NFIRST,640
         WI(I)=WI(I)*FLSAND(I)
   10    CONTINUE
      END IF
      ILOW=1
      JLOW=.TRUE.
      DO 3 I=1,NGUSER
      CRUSER(I)=0.
      REUSER(I)=0.D0
      DO 1 J=NFIRST,640
      IF (ESAND(J).GE.EUSER(I+1)) GO TO 2
      IF (ESAND(J+1).LE.EUSER(I)) GO TO 1
      EMIN=AMAX1(ESAND(J),EUSER(I))
      EMAX=AMIN1(ESAND(J+1),EUSER(I+1))
      FRAC=(EMAX-EMIN)/(ESAND(J+1)-ESAND(J))
      REUSER(I)=REUSER(I)+DPROD(FRAC,WI(J))
    1 CONTINUE
    2 CRUSER(I)=REUSER(I)/FLUSER(I)
      IF (JLOW) THEN
         IF (REUSER(I).EQ.0) THEN
            ILOW=I+1
         ELSE
            JLOW=.FALSE.
         END IF
      END IF
    3 CONTINUE
      IF (.NOT.LPT) RETURN
      IF (ILOW.LE.NGUSER) THEN
         WRITE (6,80)
         DO 5 I=ILOW,NGUSER
         WRITE (6,81) I,EUSER(I),CRUSER(I)
    5    CONTINUE
      ELSE
         WRITE (6,82) EUSER(NGUSER+1)
      END IF
      RETURN
   80 FORMAT (/' CROSS SECTIONS IN THE USER''S ENERGY GRID'//
     1   ' GROUP  E-LOW   XSECTION'/
     2   '  NO.   (eV)     (barn)'//)
   81 FORMAT (I4,1P,2E10.3)
   82 FORMAT (/' THE THRESHOLD OF THIS REACTION IS HIGHER THAN ',
     1   'THE HIGHEST ENERGY IN THE USER''S GRID (',1P,E9.3,' eV)')
      END
      SUBROUTINE ERXPLN(IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE EXPLAINS THE ERROR CODE(S) AND SETS THE DOS
C     RETURN CODE
C     STOP 0: NO ERRORS
C     STOP 1: ERRONEOUS VALUE IN THE INPUT
C     STOP 2: ERRONEOUS KEYWORD IN THE INPUT
C     STOP 3: LACK OF DATA IN THE ENDF-6 CROSS SECTION LIBRARY
C     STOP 4: ERRONEOUS I/O ORGANIZATION
C     STOP 5: PROGRAM AND/OR ENDF-6 LIBRARY ERROR
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER IER,JER,K,LER
      DIMENSION LER(11:54)
      SAVE
      DATA LER/44*0/
      IF (IER.EQ.0) STOP
      WRITE (6,1)
      IF (LER(11).GT.0) WRITE (6,11) LER(11)
      IF (LER(12).GT.0) WRITE (6,12) LER(12)
      IF (LER(13).GT.0) WRITE (6,13) LER(13)
      IF (LER(14).GT.0) WRITE (6,14) LER(14)
      IF (LER(15).GT.0) WRITE (6,15) LER(15)
      IF (LER(21).GT.0) WRITE (6,21) LER(21)
      IF (LER(22).GT.0) WRITE (6,22) LER(22)
      IF (LER(23).GT.0) WRITE (6,23) LER(23)
      IF (LER(31).GT.0) WRITE (6,31) LER(31)
      IF (LER(32).GT.0) WRITE (6,32) LER(32)
      IF (LER(33).GT.0) WRITE (6,33) LER(33)
      IF (LER(34).GT.0) WRITE (6,34) LER(34)
      IF (LER(41).GT.0) WRITE (6,41) LER(41)
      IF (LER(42).GT.0) WRITE (6,42) LER(42)
      IF (LER(43).GT.0) WRITE (6,43) LER(43)
      IF (LER(44).GT.0) WRITE (6,44) LER(44)
      IF (LER(45).GT.0) WRITE (6,45) LER(45)
      IF (LER(51).GT.0) WRITE (6,51) LER(51)
      IF (LER(52).GT.0) WRITE (6,52) LER(52)
      IF (LER(53).GT.0) WRITE (6,53) LER(53)
      IF (LER(54).GT.0) WRITE (6,54) LER(54)
      JER=IER/10
      IF (JER.EQ.1) STOP 1
      IF (JER.EQ.2) STOP 2
      IF (JER.EQ.3) STOP 3
      IF (JER.EQ.4) STOP 4
      IF (JER.EQ.5) THEN
         WRITE (6,555)
         STOP 5
      END IF
      STOP 'ILLEGAL IER CODE'
    1 FORMAT (' SUMMARY OF ERROR MESSAGES'//
     1        ' ERROR CODE CASES   EXPLANATION'//)
   11 FORMAT (' ??? 11 ???',I6,'   UNUSUAL VALUE IN THE USER''S INPUT')
   12 FORMAT (' ??? 12 ???',I6,'   TOO MANY INPUT RECORDS (SKIPPED)')
   13 FORMAT (' ??? 13 ???',I6,'   ERRONEOUS COVER DESCRIPTION ',
     1   '(REQUEST IGNORED)')
   14 FORMAT (' ??? 14 ???',I6,'   THE DETECTOR IS NOT STABLE ',
     1   '(REQUEST IGNORED)')
   15 FORMAT (' ??? 15 ???',I6,'   THE COVER IS NOT STABLE',
     1   '(REQUEST IGNORED)')
   21 FORMAT (' ??? 21 ???',I6,'   ERRONEOUS STAYNL INPUT (IGNORED)')
   22 FORMAT (' ??? 22 ???',I6,'   ERRONEOUS USER''S ENERGY GRID ',
     1   '(FATAL ERROR)')
   23 FORMAT (' ??? 23 ???',I6,'   ERRONEOUS STAYNL INPUT ',
     1   '(FATAL ERROR)')
   31 FORMAT (' ??? 31 ???',I6,'   LACKING FILE MF=3 (REQUEST IGNORED)')
   32 FORMAT (' ??? 32 ???',I6,'   LACKING FILE MF=33 ',
     1   '(REQUEST IGNORED)')
   33 FORMAT (' ??? 33 ???',I6,'   THE FILES MF=3 AND MF=33 ARE ',
     1   'INCONSISTENT')
   34 FORMAT (' ??? 34 ???',I6,'   BAD FILE MF=33 (CORR.COEFF. > 1)')
   41 FORMAT (' ??? 41 ???',I6,'   FATAL DOS ERROR')
   42 FORMAT (' ??? 42 ???',I6,'   FATAL DOS ERROR')
   43 FORMAT (' ??? 43 ???',I6,'   WRONG TASK_NAME (FATAL ERROR)')
   44 FORMAT (' ??? 44 ???',I6,'   FATAL DOS ERROR')
   45 FORMAT (' ??? 45 ???',I6,'   FATAL I/O ERROR USING THE USER''S ',
     1   'INPUT')
   51 FORMAT (' ??? 51 ???',I6,'   UNPROCESSED PROGRAM/LIBRARY ERROR: ',
     1   'I/O BUFFER OVERFLOW')
   52 FORMAT (' ??? 52 ???',I6,'   UNPROCESSED PROGRAM/LIBRARY ERROR: ',
     1   'UNEXPECTED FLAG')
   53 FORMAT (' ??? 53 ???',I6,'   UNPROCESSED PROGRAM/LIBRARY ERROR: ',
     1   'WORK MATRIX OVERFLOW')
   54 FORMAT (' ??? 54 ???',I6,'   UNPROCESSED PROGRAM/LIBRARY ERROR: ',
     1   'NC-TYPE SUB-SUBSECTION PROBLEMS')
  555 FORMAT (///
     1   ' THE CROSS SECTION LIBRARY CONTAINS FORMAT ELEMENTS'/
     1   ' OTHER THAN EXPECTED WHEN THE PROGRAM WAS DEVELOPED.'//
     2   ' SEND ALL THE PROGRAM AND DATA FILES USED IN THIS JOB'/
     3   ' TO THE ADDRESS GIVEN IN THE HOWTOUSE.TXT FILE.'//
     4   ' THANK YOU. - THE AUTHORS')
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY ERRLOG(K)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE COUNTS THE ERROR MESSAGES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      LER(K)=LER(K)+1
      RETURN
      END
      SUBROUTINE ETAP
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES THE SAND II ENERGY GRID
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL ENER,ENUL,FLSAND,P,WI,WJ
      INTEGER I,IK,IN,J
      COMMON /CSAND/ ENER(641),FLSAND(640),WI(640),WJ(641)
      DIMENSION ENUL(45)
      SAVE
      DATA ENUL/1.,1.05,1.1,1.15,1.2,1.275,1.35,1.425,1.5,1.6,1.7,1.8,
     11.9,2.,2.1,2.2,2.3,2.4,2.55,2.7,2.8,3.,3.2,3.4,3.6,3.8,4.,4.25,4.5
     2,4.75,5.,5.25,5.5,5.75,6.,6.3,6.6,6.9,7.2,7.6,8.,8.4,8.8,9.2,9.6/
      J=0
      DO 12 I=1,10
      IN=I-5
      P=10.**IN
      DO 11 IK=1,45
      J=J+1
      ENER(J)=ENUL(IK)*P
   11 CONTINUE
   12 CONTINUE
      ENER(451)=1.E+6
      DO 24 I=452,641
      ENER(I)=(I-441)*1.E+5
   24 CONTINUE
      RETURN
      END
      SUBROUTINE GENNAM(MAT,MT,NAME)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES THE REACTION NAME TO MAT,MT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVLST,GEOLST
      INTEGER I,MAT,MATLST,MT,MTLIST,NDETEC,NRREC
      CHARACTER*8 NAME,FOLNAM
      CHARACTER*2 COVNAM
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
      DO 5 I=1,NDETMX
      IF (MAT.NE.MATLST(I)) GO TO 5
      IF (MT.NE.MTLIST(I)) GO TO 5
      NAME=FOLNAM(I)
      IF (ICHAR(NAME(1:1)).GT.64) RETURN
    5 CONTINUE
   10 WRITE (NAME,15) MAT,MT
   15 FORMAT (I4,'.',I3)
      DO 20 I=1,8
      IF (NAME(I:I).EQ.' ') NAME(I:I)='0'
   20 CONTINUE
      RETURN
      END
      SUBROUTINE GENXS(IPASS,IWHICH,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE 640 GROUP SELF- AND COVER-
C     SHIELDED CROSS SECTIONS FOR THE REACTION "IWHICH"
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
      DOUBLE PRECISION DWW
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C     REAL DWW
C***** SINGLE *****
      REAL ANI,ANIS,CD,CMUSER,COVLST,COVT,CRUSER,CX,DD,DX,ENER,EUSER,
     1   FLSAND,GEOLST,GEOM,WI,WORKE,WORKS
      INTEGER I,IER,IH,IHOW,IL,IPASS,IWHICH,JA,JA0,JAC,JAD,JER,JZ,JZ0,
     1   JZC,JZD,MAT,MATLST,MAU,MT,MTLIST,MU,N1,N2,NDETEC,NGUSER,NRREC
      CHARACTER*8 FOLNAM,NAME,EIGTBL
      CHARACTER*2 COVNAM,COVN,TWOBL
      COMMON /CSAND/ ENER(641),FLSAND(640),WI(640),WORKS(641)
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      DIMENSION GEOM(2),COVT(2)
      SAVE
      DATA EIGTBL/'        '/,TWOBL/'  '/
      IHOW=1+IPASS/2
      DO 70 IH=0,IHOW
      CALL LUKSXS(IPASS,IWHICH,IH,N1,.TRUE.)
      IF (N1.NE.0) GO TO 70
      IF (IH.EQ.0) THEN
C-=-=-
C        SINGLE NUCLIDE CROSS SECTIONS
C-=-=-
         GEOM(1)=0.
         GEOM(2)=0.
         COVT(1)=0.
         COVT(2)=0.
         ANI=0.
         IF (IPASS.EQ.1) THEN
            NAME=EIGTBL
            COVN=COVNAM(IWHICH)
            MAT=0
            MT=0
         ELSE
            NAME=FOLNAM(IWHICH)
            COVN=TWOBL
            MAT=MATLST(IWHICH)
            MT=MTLIST(IWHICH)
         END IF
         IF (MAT.GE.0) THEN
            JER=0
            CALL ENDFXS(IPASS,IWHICH,JZ0,JA0,N1,JER)
            IER=MAX(IER,JER)
            IF (JER.GT.0) RETURN
            IF (MAT.EQ.0) THEN
               JAC=JA0
               JZC=JZ0
            ELSE
               JAD=JA0
               JZD=JZ0
            END IF
         ELSE
            CALL STEPXS(IWHICH,N1)
         END IF
      ELSE
C-=-=-
C        REAL DETECTOR/COVER GEOMETRY
C-=-=-
         ANI=ANIS(IWHICH)
         IF (IPASS.EQ.1) THEN
C-=-=-
C           COVER SHIELDING FACTORS
C-=-=-
            NAME=EIGTBL
            MAT=0
            MT=0
            GEOM(1)=0.
            GEOM(2)=0.
            COVN=COVNAM(IWHICH)
            COVT(1)=COVLST(1,IWHICH)
            COVT(2)=COVLST(2,IWHICH)
            CD=COVT(1)
            CX=COVT(2)
            CALL LUKSXS(IPASS,IWHICH,0,N1,.TRUE.)
            READ (9) (WORKS(I),I=N1,640)
            IF (GEOLST(1,IWHICH).GE.0.) GO TO 20
C-=-=-
C           CYLINDRICAL GEOMETRY
C           SUBSTITUED BY SANDWICH GEOMETY (VERSIONS 91-1 AND 92-1)
C-=-=-
            CONTINUE
C-=-=-
C           SANDWICH GEOMETRY, PARALLEL BEAM (SAND II APPROXIMATION)
C-=-=-
   20       WORKE=ABS(CD)
            N2=N1
            DO 22 I=N1,640
            IF (WORKS(I).GT.88.7/WORKE) THEN
               WORKS(I)=0.
               N2=N2+1
            ELSE
               WORKS(I)=EXP(-WORKE*WORKS(I))
            END IF
   22       CONTINUE
            N1=N2
         ELSE
C-=-=-
C           DETECTOR FOILS/WIRES
C-=-=-
            NAME=FOLNAM(IWHICH)
            MAT=MATLST(IWHICH)
            MT=MTLIST(IWHICH)
            GEOM(1)=GEOLST(1,IWHICH)
            GEOM(2)=GEOLST(2,IWHICH)
            DD=GEOM(1)
            DX=GEOM(2)
            IF (IH.EQ.1) THEN
C-=-=-
C              SELF-SHIELDING FACTORS
C-=-=-
               CALL LUKSXS(IPASS,IWHICH,0,N1,.TRUE.)
               READ (9) (WORKS(I),I=N1,640)
               COVN=TWOBL
               COVT(1)=0.
               COVT(2)=0.
               IF (GEOLST(1,IWHICH).GE.0.) GO TO 40
C-=-=-
C              CYLINDRICAL GEOMETRY
C              SUBSTITUED BY SANDWICH GEOMETY (VERSIONS 91-1 AND 92-1)
C-=-=-
               CONTINUE
C-=-=-
C              SANDWICH GEOMETRY, PARALLEL BEAM
C-=-=-
   40          WORKE=ABS(DD)
               N2=N1
               DO 42 I=N1,640
               DWW=DPROD(WORKS(I),WORKE)
               DWW=(1.D0-EXP(-DWW))/DWW
               DWW=WORKS(I)*DWW
               IF (DWW.GT.1.D-38) THEN
                  WORKS(I)=DWW
               ELSE
                  WORKS(I)=0.
                  IF (N2.EQ.I) N2=N2+1
               END IF
   42          CONTINUE
               N1=N2
            ELSE
C-=-=-
C              SELF- AND COVER-SHIELDED CROSS SECTIONS
C-=-=-
               COVN=COVNAM(IWHICH)
               COVT(1)=COVLST(1,IWHICH)
               COVT(2)=COVLST(2,IWHICH)
               CD=COVT(1)
               CX=COVT(2)
               CALL LUKSXS(1,IWHICH,1,N1,.TRUE.)
               IF (N1.EQ.0) THEN
                  IER=31
                  WRITE (6,80) IWHICH,FOLNAM(IWHICH),GEOLST(1,IWHICH),
     1               GEOLST(2,IWHICH),COVNAM(IWHICH),COVLST(1,IWHICH),
     2               COVLST(2,IWHICH),ANIS(IWHICH)
                  RETURN
               END IF
               READ (9) (WORKS(I),I=N1,640)
               CALL LUKSXS(IPASS,IWHICH,1,N2,.TRUE.)
               READ (9) (WI(I),I=N2,640)
               N1=MAX(N1,N2)
               N2=N1
               DO 50 I=N1,640
C***** DOUBLE *****
               DWW=DPROD(WORKS(I),WI(I))
               IF (DWW.LT.1.D-38) THEN
                  DWW=0.
                  IF (N2.EQ.I) N2=N2+1
               END IF
               WORKS(I)=DWW
C***** DOUBLE *****
C***** SINGLE *****
C              WORKS(I)=WORKS(I)*WI(I)
C              IF (WORKS(I).EQ.0..AND.N2.EQ.I) N2=N2+1
C              END IF
C***** SINGLE *****
   50          CONTINUE
               N1=N2
            END IF
         END IF
      END IF
   60 READ (9,END=61)
      GO TO 60
   61 BACKSPACE (9)
      WRITE (9) NAME,MAT,MT,GEOM,COVN,COVT,ANI,N1
      WRITE (9) (WORKS(I),I=N1,640)
      CALL COARXS(.FALSE.,N1,IL,0)
      WRITE (9) IL,(CRUSER(I),I=1,NGUSER)
      END FILE (9)
      BACKSPACE (9)
      IF (IPASS.EQ.1) THEN
         JZ=JZC
         MAU=JZ*100
         MU=1
         JA=JAC
      ELSE
         MAU=MATLST(IWHICH)
         JZ=JZD
         JA=JAD
         MU=MTLIST(IWHICH)
      END IF
      IF (MAU.GT.0)
     1   CALL XSP640(WORKS,N1,640,MAU,MU,JZ,JA,IH,NAME,GEOM,COVN,COVT)
   70 CONTINUE
      RETURN
   80 FORMAT (' '/' USER''S REQUEST LIST ITEM No =',I3//
     1  ' NAME:',T20,A/' DETSIZ:',T20,1P,2E11.3/' COVNAM:',T20,A/
     2  ' COVTHC:',T20,1P,2E11.3/' ANISOT:',T20,1P,E11.3//
     3  ' THE SELF-SHIELDED CROSS SECTION CANNOT BE FOUND'//
     4  ' ??? 31 ???   PROCESSING SKIPPED')
      END
      SUBROUTINE HEAD(TITLE,L06)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE WRITES THE HEAD OF THE OUTPUT LIST
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*(*) TITLE
      CHARACTER*3 CMONTH(12)
      CHARACTER*2 MINUCH
      INTEGER DAY,HOUR,L06,MINUTE,MONTH,SECOND,YEAR
      SAVE
      DATA CMONTH/
     1  'JAN','FEB','MAR','APR','MAY','JUN',
     2  'JUL','AUG','SEP','OCT','NOV','DEC'/
      IF (L06.LE.0) THEN
         CALL TODAY(YEAR,MONTH,DAY)
         CALL OCLOCK(HOUR,MINUTE,SECOND)
         MINUCH=CHAR(MINUTE/10+48)//CHAR(MOD(MINUTE,10)+48)
      END IF
      IF (L06.LT.0) RETURN
      WRITE (L06,1) CMONTH(MONTH),DAY,YEAR,HOUR,MINUCH,TITLE
      RETURN
    1 FORMAT (' ',18(/),
     1   17X,'XX      XX      333333       333333       333333'/
     2   17X,' XX    XX      33    33     33    33     33    33'/
     3   17X,'  XX  XX             33           33           33'/
     4   17X,'   XXXX           333          333          333'/
     5   17X,'  XX  XX             33           33           33'/
     6   17X,' XX    XX      33    33     33    33     33    33'/
     7   17X,'XX      XX      333333       333333       333333'///
     8   17X,'VERSION 95-1',16X,A3,I3,',',I5,I6,':',A2////1X,A)
      END
      SUBROUTINE INFORM(I,J,K,TITLE)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE INFORMS THE USER ON THE PROGRESS OF THE JOB
C     I: PASS, J: DETECTOR No, K: PHASE OF CALCULATION
C-=-=-
C     ANSI.SYS REQUIRED (SEE: "ANSI ESCAPE SEQUENCES" IN YOUR
C     DOS MANUAL)
C-=-=-
C     FOR BATCH PROCESSING COMMENT OUT THE STATEMENTS BETWEEN THE
C     "INTERACTIVE" MARKS AND REMOVE THE "C" IN THE FIRST COLUMN
C     BETWEEN THE "BATCH" MARKS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      CHARACTER*(*) TITLE
C***** INTERACTIVE RUN *****
      REAL AG1J,ANIS,COVLST,GEOLST,PRSNT,RUN,STRT
      INTEGER HI,HJ,HK,I,ID,J,JJ,K,LMR,MATLST,MTLIST,N,NDETEC,NRREC
      CHARACTER*9 L11C20,L18C17
      CHARACTER*8 FOLNAM,CUP,L24C1
      CHARACTER*5 L14,L15,L16,L21
      CHARACTER*4 CLS,L10
      CHARACTER*2 COVNAM
      CHARACTER*1 ESC,C,D,E,FOWI
      DIMENSION C(NDETMX),D(NDETMX),E(NDETMX)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
C***** INTERACTIVE RUN *****
C***** BATCH PROCESSING ******
C     RETURN
C***** BATCH PROCESSING ******
C***** INTERACTIVE RUN *****
      IF (I.EQ.0) THEN
         LMR=-1
         STRT=0.
         ESC=CHAR(27)
         CLS=ESC//'[2J'
         L10=ESC//'[9H'
         L14=ESC//'[12H'
         L15=ESC//'[13H'
         L16=ESC//'[14H'
         L21=ESC//'[19H'
         L24C1=ESC//'[24;1H'
         L11C20=ESC//'[10;20H'
         L18C17=ESC//'[16;17H'
         DO 1 N=1,NDETMX
         IF (N.GE.10.AND.(MOD(N,10).EQ.0.OR.MOD(N,10).EQ.1
     1      .OR.N.EQ.NDETMX)) THEN
            C(N)=CHAR(48+N/10)
         ELSE
            C(N)=' '
         END IF
    1    CONTINUE
         WRITE (0,81) CLS,TITLE,L10,L11C20,(C(N),N=1,NDETMX)
         DO 2 N=1,NDETMX
         C(N)=CHAR(48+MOD(N,10))
    2    CONTINUE
         WRITE (0,82) (C(N),N=1,NDETMX)
         DO 3 N=1,NDETEC
         C(N)='.'
         D(N)='.'
         E(N)='.'
    3    CONTINUE
         WRITE (0,83) L14,(C(N),N=1,NDETEC)
         WRITE (0,84) L15,(D(N),N=1,NDETEC)
         WRITE (0,85) L16,(E(N),N=1,NDETEC)
         WRITE (0,86) L18C17
         JJ=20+NDETEC+NDETEC/10
         RETURN
      END IF
      IF (GEOLST(1,J).GE.0) THEN
         FOWI='='
      ELSE
         FOWI='@'
      END IF
      AG1J=ABS(GEOLST(1,J))
      WRITE (0,90) L21,FOLNAM(J),FOWI,AG1J,GEOLST(2,J),COVNAM(J),
     1   COVLST(1,J),COVLST(2,J),ANIS(J)
      STRT=0.
      GO TO (10,20,30),I
   10 GO TO (11,11,13),K
   11 C(J)='x'
      GO TO 14
   13 C(J)='X'
   14 WRITE (0,83) L14,(C(N),N=1,J)
      WRITE (CUP,93) ESC,JJ
      WRITE (0,91) CUP
      RETURN
   20 GO TO (21,22,23),K
   21 D(J)='x'
      GO TO 24
   22 D(J)='c'
      GO TO 24
   23 ID=ICHAR(D(J))
      IF (ID.GE.97) D(J)=CHAR(ICHAR(D(J))-32)
   24 WRITE (0,84) L15,(D(N),N=1,J)
      WRITE (CUP,94) ESC,JJ
      WRITE (0,91) CUP
      RETURN
   30 GO TO (31,33,33),K
   31 E(J)='x'
      GO TO 34
   33 E(J)='X'
   34 WRITE (0,85) L16,(E(N),N=1,J)
      WRITE (CUP,95) ESC,JJ
      WRITE (0,91) CUP
      RETURN
C***** INTERACTIVE RUN *****
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY WRKING
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE REMEMBERS THE USER THAT THE PROGRAM IS WORKING
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C***** INTERACTIVE RUN *****
      CALL OCLOCK(HI,HJ,HK)
      PRSNT=60*(60*HI+HJ)+HK
      RUN=PRSNT-STRT
      IF (RUN.GT.10.) THEN
         STRT=PRSNT
         IF (LMR.LT.0) THEN
            WRITE (0,71) L24C1
            LMR=0
         ELSE IF (LMR.EQ.0) THEN
            WRITE (0,72) L24C1
            LMR=1
         ELSE
            WRITE (0,73) L24C1
            LMR=-1
         END IF
         WRITE (0,91) CUP
      END IF
C***** INTERACTIVE RUN *****
      RETURN
C-=-=-
C     THE FORMAT STATEMENTS CORRESPOND WITH NDETEC=50
C-=-=-
C***** INTERACTIVE RUN *****
C***** RYAN-McFARLAND 1.00, 2.42 *****
C  71 FORMAT (1X,A,10X,'WORKING...',54X)
C  72 FORMAT (1X,A,35X,'WORKING...',25X)
C  73 FORMAT (1X,A,62X,'WORKING...')
C  81 FORMAT (A/
C    1   27X,'X   X   333    333    333'/
C    2   27X,' X X       3      3      3'/
C    3   27X,'  X      33     33     33'/
C    4   27X,' X X       3      3      3'/
C    5   27X,'X   X   333    333    333'/80(''),
C    6   A/A,80(''),A,5(10A1,1X))
C  82 FORMAT ('User''s request No:  ',5(10A1,1X))
C  86 FORMAT (A,'xX  cross sections      cC  covariance matrices'/
C    1      17X,'xc  under processing    XC  finished'///
C    2      12X,'      ',
C    3      '  '/
C    4      12X,'  name          geometry       cover ',
C    5      '  cover geometry   anisotropy'/80(''))
C  93 FORMAT (A1,'[11;',I2,'H')
C  94 FORMAT (A1,'[12;',I2,'H')
C  95 FORMAT (A1,'[13;',I2,'H')
C***** RYAN-McFARLAND 1.00, 2.42 *****
C***** LAHEY F77L3, MICROSOFT 5.00 *****
   71 FORMAT (1X,A,10X,'WORKING...',51X,'.')
   72 FORMAT (1X,A,35X,'WORKING...',26X,'.')
   73 FORMAT (1X,A,62X,'WORKING...')
   81 FORMAT (1X,A/
     1   27X,'X   X   333    333    333'/
     2   27X,' X X       3      3      3'/
     3   27X,'  X      33     33     33'/
     4   27X,' X X       3      3      3'/
     5   27X,'X   X   333    333    333'/1X,80(''),
     6   1X,A,1X,A,80(''),A,5(10A1,1X))
   82 FORMAT (' User''s request No:  ',5(10A1,1X))
   86 FORMAT (1X,A,'xX  cross sections      cC  covariance matrices'/
     1      18X,'xc  under processing    XC  finished'///
     2      13X,'      ',
     3      '  '/
     4      13X,'  name          geometry       cover ',
     5      '  cover geometry   anisotropy'/1X,80(''))
   93 FORMAT (A1,'[12;',I2,'H')
   94 FORMAT (A1,'[13;',I2,'H')
   95 FORMAT (A1,'[14;',I2,'H')
C***** LAHEY F77L3, MICROSOFT 5.00 *****
   83 FORMAT (1X,A,' Pass 1: covers     ',5(10A1,1X))
   84 FORMAT (1X,A,' Pass 2: detectors  ',5(10A1,1X))
   85 FORMAT (1X,A,' Pass 3: responses  ',5(10A1,1X))
   90 FORMAT (1X,A,'Processing: ',A8,2X,A1,1P,2E10.2,2X,A2,1P,2E10.2,
     1  0P,F8.2)
   91 FORMAT (1X,A:A)
C***** INTERACTIVE RUN *****
      END
      SUBROUTINE LUKXSL(IWHAT,SHALL,NREC)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE LOOKS FOR THE "IWHAT" DETECTOR SET IN THE
C     TASK_NAME.XSL LIBRARY
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL ANI,ANIS,CMUSER,CRUSER,COVLST,COVSIZ,DETSIZ,EUSER,GEOLST
      INTEGER I,IPO,IWHAT,KOVFLG,M1,M2,MATLST,MTLIST,N1STU,NDBLK,NDETEC,
     1   NGUSER,NOTUSD,NRC,NREC,NRREC
      LOGICAL SHALL
      CHARACTER*8 FOLNAM,NAME
      CHARACTER*2 COVNAM,CNAM
      DIMENSION DETSIZ(2),COVSIZ(2)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      SAVE
      READ (4,REC=4) NDBLK,NOTUSD
      NRC=5
      IPO=IWHAT
      DO 10 I=1,NDBLK
      READ (4,REC=NRC) NAME,DETSIZ,CNAM,COVSIZ,ANI,
     1   M1,M2,N1STU,KOVFLG
      IF (M1.LT.0.AND.M2.LT.0) THEN
         IF (NAME.NE.FOLNAM(IPO)) GO TO 5
      ELSE
          IF (M1.NE.MATLST(IPO)) GO TO 5
          IF (M2.NE.MTLIST(IPO)) GO TO 5
      END IF
      IF (DETSIZ(1).NE.GEOLST(1,IPO)) GO TO 5
      IF (DETSIZ(2).NE.GEOLST(2,IPO)) GO TO 5
      IF (CNAM.NE.COVNAM(IPO)) GO TO 5
      IF (COVSIZ(1).NE.COVLST(1,IPO)) GO TO 5
      IF (COVSIZ(2).NE.COVLST(2,IPO)) GO TO 5
      IF (ANI.NE.ANIS(IPO)) GO TO 5
      SHALL=.FALSE.
      NREC=NRC
      RETURN
    5 NRC=NRC+2
      IF (KOVFLG.GT.0) NRC=NRC+NGUSER-N1STU+1
   10 CONTINUE
      SHALL=.TRUE.
      NREC=0
      RETURN
      END
      SUBROUTINE MATSEL(IPASS,LINE,NEW1,NEW2)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE SELECTS THE NEXT ITEM FROM THE USER'S INPUT:
C     IPASS=1:  COVER MATERIAL DATA
C           2:  RESPONSE FUNCTIONS (INCLUDING ACTIVATION DETECTOR DATA)
C           3:  RADIATION DAMAGE EXPOSURE PARAMETER DATA, FURTHERMORE
C               RESPONSE FUNCTIONS WITHOUT DATA IN FILE MF=33,
C     AND CHECKS IF
C           THE CROSS SECTIONS (NEW1) AND/OR
C           THE COVARIANCES (NEW2)
C     HAVE TO BE CALCULATED TO THE LINE-TH INPUT LINE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      INTEGER IP,IPASS,IPO,LINE,MATLST,MTLIST,NDETEC,NFIRST,
     1   NONE,NRREC
      REAL ANIS,COVLST,GEOLST
      LOGICAL NEW1,NEW2,N1,N2
      CHARACTER*8 FOLNAM
      CHARACTER*2 COVNAM,TWOBL
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      SAVE
      DATA TWOBL/'  '/
      IPO=LINE
      N1=.FALSE.
      N2=.FALSE.
      IF (IPASS.GT.2) GO TO 30
      IF (IPASS.EQ.2) GO TO 20
C-=-=-
C     COVER CROSS SECTIONS
C-=-=-
      IF (IPO.EQ.1) THEN
         N1=COVNAM(1).NE.TWOBL.AND.(COVLST(1,1).NE.0.)
      ELSE
         IF (COVNAM(IPO).NE.TWOBL) THEN
            DO 15 IP=1,IPO-1
            IF (COVNAM(IP).NE.COVNAM(IPO)) GO TO 15
            IF (COVLST(1,IP).NE.COVLST(1,IPO)) GO TO 15
            IF (COVLST(2,IP).NE.COVLST(2,IPO)) GO TO 15
            IF (ANIS(IP).NE.ANIS(IPO)) GO TO 15
            GO TO 40
   15       CONTINUE
            N1=.TRUE.
         END IF
      END IF
      GO TO 40
C-=-=-
C     DETECTOR CROSS SECTIONS
C-=-=-
   20 IP=MTLIST(IPO)
      IF (IP.LT.0.OR.IP.GT.200) GO TO 26
      IF (IPO.EQ.1) THEN
         N1=.TRUE.
      ELSE
         DO 25 IP=1,IPO-1
         IF (FOLNAM(IP).NE.FOLNAM(IPO)) GO TO 25
         IF (GEOLST(1,IP).NE.GEOLST(1,IPO)) GO TO 25
         IF (GEOLST(2,IP).NE.GEOLST(2,IPO)) GO TO 25
         IF (COVNAM(IP).NE.COVNAM(IPO)) GO TO 25
         IF (COVLST(1,IP).NE.COVLST(1,IPO)) GO TO 25
         IF (COVLST(2,IP).NE.COVLST(2,IPO)) GO TO 25
         IF (ANIS(IP).NE.ANIS(IPO)) GO TO 25
         GO TO 26
   25    CONTINUE
         N1=.TRUE.
      END IF
   26 N2=N1
      GO TO 40
C-=-=-
C     RESPONSE CROSS SECTIONS
C-=-=-
   30 IF (MTLIST(IPO).LE.200.AND.NRREC(2,IPO).GT.0) GO TO 45
      DO 35 IP=1,NDETEC
      IF (IP.EQ.IPO) GO TO 35
      IF (FOLNAM(IP).NE.FOLNAM(IPO)) GO TO 35
      IF (GEOLST(1,IP).NE.GEOLST(1,IPO)) GO TO 35
      IF (GEOLST(2,IP).NE.GEOLST(2,IPO)) GO TO 35
      IF (COVNAM(IP).NE.COVNAM(IPO)) GO TO 35
      IF (COVLST(1,IP).NE.COVLST(1,IPO)) GO TO 35
      IF (COVLST(2,IP).NE.COVLST(2,IPO)) GO TO 35
      IF (ANIS(IP).NE.ANIS(IPO)) GO TO 35
      GO TO 40
   35 CONTINUE
      N1=.TRUE.
   40 IF (N1) THEN
         CALL LUKSXS(IPASS,IPO,2,NFIRST,.TRUE.)
         N1=NFIRST.EQ.0
      END IF
      IF (IPASS.EQ.1) GO TO 45
      IF (N1) CALL LUKXSL(IPO,N2,NONE)
   45 NEW1=N1
      NEW2=N2
      RETURN
      END
