      SUBROUTINE PRLTCM(IL,IH,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PRINTS THE LOWER TRIANGLE OF A CORRELATION MATRIX
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL CMUSER,CRUSER,EUSER,SDEV
      INTEGER I,IER,IH,IL,ISIZE,J,KOR,NGUSER,NOTCOR
      CHARACTER*9 MTS
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      DIMENSION SDEV(NGUMAX),KOR(NGUMAX)
      SAVE
      ISIZE=IH-IL+1
      IF (ISIZE.LE.9) THEN
         WRITE (MTS,91) ISIZE,ISIZE
      ELSE IF (ISIZE.LE.99) THEN
         WRITE (MTS,92) ISIZE,ISIZE
      ELSE
         WRITE (MTS,93) ISIZE,ISIZE
      END IF
      WRITE (6,80) MTS
      NOTCOR=0
      DO 1 I=IL,IH
      SDEV(I)=SQRT(ABS(CMUSER(I,I)))
      IF (SDEV(I).EQ.0.) IER=33
    1 CONTINUE
      DO 3 I=IL,IH
      DO 2 J=IL,I
      KOR(J)=0
      IF (SDEV(I).NE.0..AND.SDEV(J).NE.0.)
     1   KOR(J)=NINT((CMUSER(I,J)/(SDEV(I)*SDEV(J)))*100.)
      IF (KOR(J).LT.-100.OR.KOR(J).GT.100) NOTCOR=NOTCOR+1
    2 CONTINUE
      WRITE (6,81) I,EUSER(I),CRUSER(I),SDEV(I),(KOR(J),J=IL,I)
    3 CONTINUE
      IF (IER.GT.0) THEN
         WRITE (6,82)
         WRITE (6,83)
         CALL ERRLOG(33)
      END IF
      IF (NOTCOR.GT.0) THEN
         WRITE (6,82)
         WRITE (6,84)
         CALL ERRLOG(34)
      END IF
      RETURN
   80 FORMAT (/' XSECTION CORRELATION MATRIX ',A,10X,'LOWER TRIANGLE'//
     1   ' GROUP  E-LOW   XSECTION   S.DEV.   100*CORR. COEFF.'/
     2   '  NO.   (eV)     (barn)     (%)'//)
   81 FORMAT (I4,1P,2E10.3,0P,2P,F8.2,I7,19I4:/(I39,19I4))
   82 FORMAT (//' ERROR IN THE MASTER CROSS SECTION LIBRARY.')
   83 FORMAT (/' ??? 33 ??? THE COVARIANCE INFORMATION IN FILE MF=33',
     1   ' DOES NOT COVER THE WHOLE ENERGY RANGE OF THE FILE MF=3'//
     2   ' THE 00.00 % STANDARD DEVIATION HAS NO MEANING.')
   84 FORMAT (//' ??? 34 ??? BAD COVARIANCE INFORMATION IN FILE MF=33'//
     1   ' THE CORRELATION COEFFICIENTS OUT OF RANGE -100...+100',
     2   ' HAVE NO MEANING.')
   91 FORMAT ('(',I1,'*',I1,')    ')
   92 FORMAT ('(',I2,'*',I2,')  ')
   93 FORMAT ('(',I3,'*',I3,')')
      END
      SUBROUTINE READER(L613,NR,NG,NG1,NAME,A0,SDA0R,A0M,
     1    EL,F,SDFR,FM,SPECID,WSP,IER,BUO)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE READS THE USER'S DATA AND WRITES THE INPUT LOG
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL A0,A0M,C11,EL,F,FM,SDA0R,SDFR,WSP
      INTEGER I,IER,J,JER,L613,L78,NG,NG1,NR
      CHARACTER*80 SPECID,CARD
      CHARACTER*8 NAME
      CHARACTER*5 KEYW2
      CHARACTER*3 KEYW1
      LOGICAL ALTRET,BUO,PAGE
      SAVE
      DIMENSION A0(NR),SDA0R(NR),A0M(NR,NR),EL(NG1),F(NG),
     1  SDFR(NG),FM(NG,NG),NAME(NR),WSP(640)
    1 FORMAT (/' ??? 23 ??? KEYWORD ERROR: ',A)
    2 FORMAT (' '//' INPUT LOG:'//2I5)
    3 FORMAT (/1X,A)
    4 FORMAT (12F10.3)
    5 FORMAT (1P,12E10.3)
    6 FORMAT (A)
    7 FORMAT (' ')
      JER=0
      PAGE=L613.EQ.13
      WRITE (L613,2) NR,NG
      CALL NOCOMM(.FALSE.,8,L78)
      CALL USERQL(L613,L78,NR,A0,NAME,JER)
      IER=MAX(IER,JER)
      DO 12 I=1,NR
      IF (A0(I).LE.0.) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,11) I,NAME(I),A0(I)
   11    FORMAT (/I3,3X,A8,1P,E13.4,' ??? 21 ??? MEANINGLESS ACTIVITY!')
         IER=MAX(IER,21)
         CALL ERRLOG(21)
      END IF
   12 CONTINUE
      CALL TRALER(L78,L613,CARD,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
      WRITE (L613,3) KEYW1
      IF (KEYW1.EQ.'STD') THEN
         READ (L78,*,ERR=99,END=99) SDA0R
         WRITE (L613,4) SDA0R
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) ((A0M(J,I),J=1,I),I=1,NR)
            DO 13 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,I)
   13       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) ((A0M(J,I),J=I,NR),I=1,NR)
            DO 14 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   14       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*,END=99) A0M
            DO 15 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   15       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'MIX') THEN
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) (SDA0R(I),(A0M(J,I),J=1,I),I=1,NR)
            DO 16 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=1,I)
   16       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) (SDA0R(I),(A0M(J,I),J=I,NR),I=1,NR)
            DO 17 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   17       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*) (SDA0R(I),(A0M(J,I),J=1,NR),I=1,NR)
            DO 18 I=1,NR
            WRITE (L613,4) SDA0R(I)
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   18       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'REL') THEN
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) ((A0M(J,I),J=1,I),I=1,NR)
            DO 19 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,I)
   19       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) ((A0M(J,I),J=I,NR),I=1,NR)
            DO 20 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=I,NR)
   20       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*) ((A0M(J,I),J=1,NR),I=1,NR)
            DO 21 I=1,NR
            WRITE (L613,4) (A0M(J,I),J=1,NR)
   21       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
            DO 22 I=1,NR
            SDA0R(I)=SQRT(A0M(I,I))
   22       CONTINUE
      ELSE
C-=-=-
C        STAYNL: INPUT
C        WRITE (6,1) KEYW1
C        IER=MAX(IER,23)
C        CALL ERRLOG(23)
C        RETURN
C-=-=-
C        X333: OPTIONAL INPUT
         GO TO 45
C-=-=-
      END IF
      DO 32 I=1,NR
      IF (SDA0R(I).LE.0.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,30) I,NAME(I),SDA0R(I)
   30    FORMAT (/I3,3X,A8,F12.5,
     1      ' ??? 22 ??? MEANINGLESS ACTIVITY STD!')
         IER=MAX(IER,22)
         CALL ERRLOG(22)
      ELSE IF (SDA0R(I).LT.1.D0 .OR. SDA0R(I).GT.10.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,31) I,NAME(I),SDA0R(I)
   31    FORMAT (/I3,3X,A8,F12.5,
     1      ' ??? 11 ??? CHECK THE ACTIVITY STD VALUE!')
         IER=MAX(IER,11)
         CALL ERRLOG(11)
      END IF
   32 CONTINUE
      IF (KEYW2.EQ.'UPPER') THEN
         DO 140 J=2,NR
         DO 40 I=1,J-1
         A0M(J,I)=A0M(I,J)
   40    CONTINUE
  140    CONTINUE
      ELSE IF (KEYW2.EQ.'LOWER') THEN
         DO 141 J=2,NR
         DO 41 I=1,J-1
         A0M(I,J)=A0M(J,I)
   41    CONTINUE
  141    CONTINUE
      END IF
      C11=A0M(1,1)
      DO 143 I=1,NR
      DO 43 J=1,I
      A0M(J,I)=A0M(J,I)/C11
      IF ((I.EQ.J).AND.DABS(A0M(J,I)-1.D0).GT..00001D0
     1   .OR. A0M(J,I).LT.-1.00001D0
     2   .OR. A0M(J,I).GT.+1.00001D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,42) I,J,A0M(J,I)
   42    FORMAT (/2I3,F10.5,
     1      ' ??? 21 ??? MEANINGLESS CORRELATION COEFFICIENT!')
         IER=MAX(IER,21)
         CALL ERRLOG(21)
      ELSE
         A0M(I,J)=A0M(J,I)
      END IF
   43 CONTINUE
  143 CONTINUE
      CALL TRALER(L78,L613,CARD,ALTRET)
      IF (ALTRET) GO TO 99
   45 KEYW2=CARD(1:5)
      WRITE (L613,3) KEYW2
      IF (KEYW2.NE.'ENLIM') THEN
         WRITE (6,1) KEYW2
         IER=MAX(IER,23)
         CALL ERRLOG(23)
         RETURN
      END IF
      READ (L78,*,END=99) EL
      WRITE (L613,5) EL
      DO 51 I=1,NG1
      IF (EL(I).LE.0.) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,50) I,EL(I)
   50    FORMAT (/I3,1P,E11.3,' ??? 22 ??? MEANINGLESS ENERGY!')
         IER=MAX(IER,22)
         CALL ERRLOG(22)
      END IF
      IF (I.EQ.1) GO TO 51
      IF (EL(I-1).GE.EL(I)) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,50) I,EL(I)
         IER=MAX(IER,22)
         CALL ERRLOG(22)
      END IF
   51 CONTINUE
      CALL TRALER(L78,L613,CARD,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW2=CARD(1:5)
      WRITE (L613,3) KEYW2
      IF (KEYW2.EQ.'DFIDE') THEN
         READ (L78,*,END=99) F
         WRITE (L613,5) F
         DO 53 I=1,NG
         IF (F(I).GT.0.D0) THEN
            F(I)=F(I)*(EL(I+1)-EL(I))
         ELSE
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
   52       FORMAT (/I3,1P,E11.3,' ??? 21 ??? MEANINGLESS FLUX!')
            IER=MAX(IER,21)
            CALL ERRLOG(21)
         END IF
   53    CONTINUE
      ELSE IF (KEYW2.EQ.'DFIDU') THEN
         READ (L78,*,END=99) F
         WRITE (L613,5) F
         DO 54 I=1,NG
         IF (F(I).GT.0.) THEN
            F(I)=F(I)*LOG(EL(I+1)/EL(I))
         ELSE
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
            IER=MAX(IER,21)
            CALL ERRLOG(21)
         END IF
   54    CONTINUE
      ELSE IF (KEYW2.EQ.'FIGRP') THEN
         READ (L78,*,END=99) F
         WRITE (L613,5) F
         DO 55 I=1,NG
         IF (F(I).LE.0.D0) THEN
            IF (PAGE) THEN
               PAGE=.FALSE.
               WRITE (6,7)
            END IF
            WRITE (6,52) I,F(I)
            IER=MAX(IER,21)
            CALL ERRLOG(21)
         END IF
   55    CONTINUE
      ELSE
C-=-=-
C        STAYNL: INPUT
C        WRITE (6,1) KEYW2
C        IER=MAX(IER,23)
C        CALL ERRLOG(23)
C        RETURN
C-=-=-
C        X333: OPTIONAL INPUT
         KEYW1=KEYW2(1:3)
         GO TO 56
C-=-=-
      END IF
      CALL TRALER(L78,L613,CARD,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
   56 WRITE (L613,3) KEYW1
      IF (KEYW1.EQ.'STD') THEN
         READ (L78,*,END=99) SDFR
         WRITE (L613,4) SDFR
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) ((FM(J,I),J=1,I),I=1,NG)
            DO 60 I=1,NG
            WRITE (L613,4) (FM(J,I),J=1,I)
   60       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) ((FM(J,I),J=I,NG),I=1,NG)
            DO 61 I=1,NG
            WRITE (L613,4) (FM(J,I),J=I,NG)
   61       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*,END=99) FM
            DO 62 I=1,NG
            WRITE (L613,4) (FM(J,I),J=1,NG)
   62       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'MIX') THEN
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) (SDFR(I),(FM(J,I),J=1,I),I=1,NG)
            DO 63 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=1,I)
   63       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) (SDFR(I),(FM(J,I),J=I,NG),I=1,NG)
            DO 64 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=I,NG)
   64       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*) (SDFR(I),(FM(J,I),J=1,NG),I=1,NG)
            DO 65 I=1,NG
            WRITE (L613,4) SDFR(I)
            WRITE (L613,4) (FM(J,I),J=1,NG)
   65       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
      ELSE IF (KEYW1.EQ.'REL') THEN
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW2=CARD(1:5)
         WRITE (L613,3) KEYW2
         IF (KEYW2.EQ.'UPPER') THEN
            READ (L78,*,END=99) ((FM(J,I),J=1,I),I=1,NR)
            DO 66 I=1,NR
            WRITE (L613,4) (FM(J,I),J=1,I)
   66       CONTINUE
         ELSE IF (KEYW2.EQ.'LOWER') THEN
            READ (L78,*,END=99) ((FM(J,I),J=I,NR),I=1,NR)
            DO 67 I=1,NR
            WRITE (L613,4) (FM(J,I),J=I,NR)
   67       CONTINUE
         ELSE IF (KEYW2.EQ.'QUADR') THEN
            READ (L78,*) ((FM(J,I),J=1,NR),I=1,NR)
            DO 68 I=1,NR
            WRITE (L613,4) (FM(J,I),J=1,NR)
   68       CONTINUE
         ELSE
            WRITE (6,1) KEYW2
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
            DO 69 I=1,NR
            SDFR(I)=SQRT(FM(I,I))
   69       CONTINUE
      ELSE
C-=-=-
C        STAYNL: INPUT
C        WRITE (6,1) KEYW1
C        IER=MAX(IER,23)
C        CALL ERRLOG(23)
C        RETURN
C-=-=-
C        X333: OPTIONAL INPUT
         KEYW1=KEYW2(1:3)
         GO TO 84
C-=-=-
      END IF
      DO 78 I=1,NG
      IF (SDFR(I).LE.0.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,76) I,SDFR(I)
   76    FORMAT (/I3,F10.5,' ??? 21 ??? MEANINGLESS FLUX STD!')
         IER=MAX(IER,21)
         CALL ERRLOG(21)
      ELSE IF (SDFR(I).LT.10.D0 .OR. SDFR(I).GT.25.D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,77) I,SDFR(I)
   77    FORMAT (/I3,F10.5,' ??? 11 ??? CHECK THE FLUX STD VALUE!')
         IER=MAX(IER,11)
         CALL ERRLOG(11)
      END IF
   78 CONTINUE
      IF (KEYW2.EQ.'UPPER') THEN
         DO 180 J=2,NG
         DO 80 I=1,J-1
         FM(J,I)=FM(I,J)
   80 CONTINUE
  180 CONTINUE
      ELSE IF (KEYW2.EQ.'LOWER') THEN
         DO 181 J=2,NG
         DO 81 I=1,J-1
         FM(I,J)=FM(J,I)
   81    CONTINUE
  181    CONTINUE
      END IF
      C11=FM(1,1)
      DO 183 I=1,NG
      DO 83 J=1,I
      FM(J,I)=FM(J,I)/C11
      IF ((I.EQ.J).AND.ABS(FM(J,I)-1.D0).GT..00001D0
     1   .OR. FM(J,I).LT.-1.00001D0
     2   .OR. FM(J,I).GT.+1.00001D0) THEN
         IF (PAGE) THEN
            PAGE=.FALSE.
            WRITE (6,7)
         END IF
         WRITE (6,42) I,J,FM(J,I)
         IER=MAX(IER,21)
         CALL ERRLOG(21)
      ELSE
         FM(I,J)=FM(J,I)
      END IF
   83 CONTINUE
  183 CONTINUE
      CALL TRALER(L78,L613,CARD,ALTRET)
      IF (ALTRET) GO TO 99
      KEYW1=CARD(1:3)
   84 WRITE (L613,3) KEYW1
      IF (KEYW1.EQ.'END') THEN
         JER=0
         CALL CNNWSP(SPECID,WSP,JER,BUO)
         WRITE (L613,85) SPECID,WSP
   85    FORMAT (1X,A/(1P,12E10.3))
         IER=MAX(IER,JER)
         RETURN
      ELSE IF (KEYW1.EQ.'WSP') THEN
         READ (L78,6,END=99) SPECID
         READ (L78,*,END=99) WSP
         WRITE (L613,85) SPECID,WSP
         CALL TRALER(L78,L613,CARD,ALTRET)
         IF (ALTRET) GO TO 99
         KEYW1=CARD(1:3)
         WRITE (L613,3) KEYW1
         IF (KEYW1.EQ.'END') THEN
            RETURN
         ELSE
            IF (L613.EQ.13) WRITE (6,85) SPECID,WSP
            WRITE (6,1) KEYW1
            IER=MAX(IER,23)
            CALL ERRLOG(23)
            RETURN
         END IF
      ELSE
         WRITE (6,1) KEYW1
         IER=MAX(IER,23)
         CALL ERRLOG(23)
         RETURN
      END IF
   99 IER=45
      WRITE (6,98)
   98 FORMAT (' ??? 45 ??? DOS ERROR READING THE USER''S INPUT')
      CALL ERRLOG(45)
      RETURN
      END
      SUBROUTINE RESAND(EL,EH,IW,IP,NFIRST,IRESP)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE DETECTOR RESPONSE GROUP BY GROUP
C     IN THE 640 GROUP SAND II STRUCTURE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,COVLST,CRSAND,EH,EL,ESAND,FLSAND,GEOLST,R01,R05,R50,
     1   R95,R99,RESPNS,RREL,RTOT,WJ
      INTEGER I,IH,IL,IP,IR,IRESP,IW,J,JRESP,MATLST,MFLAG,MTLIST,
     1   NDETEC,NFIRST,NRREC
      COMMON /CSAND/ ESAND(641),FLSAND(640),RESPNS(640),WJ(641)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      DIMENSION CRSAND(640),IR(5),IRESP(*),JRESP(*)
      SAVE
      DATA IR/1,5,50,95,99/
      CALL INTERV(EL,IL,MFLAG)
      CALL INTERV(EH,IH,MFLAG)
      CALL LUKSXS(IW,IP,2,NFIRST,.TRUE.)
      READ (9) (CRSAND(I),I=NFIRST,640)
      DO 12 I=1,NFIRST-1
      RESPNS(I)=0.
      CRSAND(I)=0.
   12 CONTINUE
      RTOT=0.
      DO 101 I=NFIRST,640
      IF (I.LT.IL.OR.I.GT.IH) GO TO 107
      IF (I.EQ.IL.AND.IL.EQ.IH) GO TO 109
      IF (I.EQ.IL) GO TO 111
      IF (I.EQ.IH) GO TO 113
      GO TO 115
  107 RESPNS(I)=0.
      GO TO 101
  109 RESPNS(I)=FLSAND(I)
      GO TO 117
  111 RESPNS(I)=FLSAND(I)*((ESAND(I+1)-EL)/(ESAND(I+1)-ESAND(I)))
      GO TO 117
  113 RESPNS(I)=FLSAND(I)*((EH-ESAND(I))/(ESAND(I+1)-ESAND(I)))
      GO TO 117
  115 RESPNS(I)=FLSAND(I)
  117 RESPNS(I)=RESPNS(I)*CRSAND(I)
      RTOT=RTOT+RESPNS(I)
  101 CONTINUE
      RREL=0.
      R01=.01*RTOT
      R05=.05*RTOT
      R50=.50*RTOT
      R95=.95*RTOT
      R99=.99*RTOT
      DO 120 I=NFIRST,640
      IF (RREL.LE.R01.AND.RREL+RESPNS(I).GT.R01) IRESP(1)=I
      IF (RREL.LE.R05.AND.RREL+RESPNS(I).GT.R05) IRESP(2)=I
      IF (RREL.LE.R50.AND.RREL+RESPNS(I).GT.R50) IRESP(3)=I
      IF (RREL.LE.R95.AND.RREL+RESPNS(I).GT.R95) IRESP(4)=I
      IF (RREL.LE.R99.AND.RREL+RESPNS(I).GT.R99) THEN
         IRESP(5)=I
         RETURN
      END IF
      RREL=RREL+RESPNS(I)
  120 CONTINUE
      IRESP(5)=640
      RETURN
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY RESANL(JRESP)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE WRITES THE ENERGIES TO THE 1,5,50,95 AND 99 %
C     RESPONSE LIMITS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      WRITE (6,131)
      DO 130 J=1,5
      I=JRESP(J)
      WRITE (6,132) IR(J),ESAND(I),ESAND(I+1)
  130 CONTINUE
      RETURN
  131 FORMAT (//)
  132 FORMAT (' THE',I3,' % RESPONSE LIMIT LIES BETWEEN THE ENERGIES',
     1   1P,E10.3,' AND',1P,E10.3,' eV')
      END
