      SUBROUTINE SCTION(L613,IWHICH,IP33,ILOW,KOVFLG,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PROCESSES THE SUBSECTIONS OF THE ENDF-6 FILE MF=33
C     IP33 = RECORD NO OF MF=33 IN THE LIBRARY
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL CI,CMUSER,CRUSER,E,E1,E2,ESAND,ESUM,EUSER,FFIJN,FLSAND,
     1   RSPTOT,WI,WJ,XLFS1,XMF1
      INTEGER I,IER,ILOW,IP33,IRESP,ISUM,IWHICH,J,JER,KOVFLG,L613,LFS1,
     1   LTY,MAT,MAT1,MATS,MF1,MP,MR,MT,MT1,MTS,MTI,NAT1,NT1,NC,
     2   NGUSER,NI,NL,NP,NPNP,NPOI
      CHARACTER*2 CNC,CNI
      COMMON /CENDF/ E1,E2,E(641),FFIJN(NGEMAX,NGEMAX),LTY,NP,MP
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      COMMON /SUBSUB/ NPNP,NPOI(3,NSSMAX)
      COMMON /SUMXS/ ISUM,ESUM(2),CI(NSSMAX),MTI(NSSMAX)
      DIMENSION IRESP(5)
      SAVE
      DATA CNC,CNI/'NC','NI'/
      KOVFLG=0
      REWIND (12)
      MR=IP33
      READ (3,80,REC=MR) NL
      MR=MR+1
      WRITE (L613,70) NL
      DO 19 I=1,NL
      CALL WRKING
      WRITE (L613,81) I
      READ (3,82,REC=MR) XMF1,XLFS1,MAT1,MT1,NC,NI
      MR=MR+1
      MF1=NINT(XMF1)
      LFS1=NINT(XLFS1)
      IF (MF1.NE.10) THEN
         WRITE (L613,83) MAT1,MF1,MT1
      ELSE
         WRITE (L613,84) MAT1,MT1,LFS1
      END IF
      NAT1=MAT1
      NT1=MT1
      IF (NAT1.EQ.0) NAT1=MAT
      IF (NT1.EQ.0) NT1=MT
      WRITE (L613,85) CNC,NC,CNI,NI
      WRITE (L613,86)
      DO 15 J=1,NC
      CALL SUBNC(L613,MR,J,MAT,MATS,MTS)
   15 CONTINUE
      DO 17 J=1,NI
      JER=0
      CALL SUBNI(L613,IWHICH,MR,J,MAT,MT,NAT1,MF1,NT1,LFS1,ILOW,
     1   IRESP,JER)
      IER=MAX(IER,JER)
      IF (JER.GT.0) RETURN
   17 CONTINUE
      WRITE (L613,87) I
   19 CONTINUE
      CALL RESANL(IRESP)
      WRITE (L613,91)
      RSPTOT=0.D0
      DO 24 I=ILOW,NGUSER
      RSPTOT=RSPTOT+REUSER(I)
      WRITE (L613,92) I,EUSER(I),EUSER(I+1),REUSER(I)
   24 CONTINUE
      WRITE (L613,93) EUSER(1),EUSER(NGUSER+1),RSPTOT
      KOVFLG=1
      RETURN
   70 FORMAT (//' NUMBER OF SUBSECTIONS: NL =',I3)
   80 FORMAT (55X,I11)
   81 FORMAT (////1X,53('-'),' SUB-SECTION NO.:',I3,1X,53('-'))
   82 FORMAT (2F11.0,4I11)
   83 FORMAT (' SUBSECTION IDENTIFICATION',26X,
     1   ': MAT1,MF1,MT1=',I5,I3,I4)
   84 FORMAT (' SUBSECTION IDENTIFICATION',26X,
     1   ': MAT1,MT1,LFS1=',I5,I3,I4)
   85 FORMAT (' NUMBER OF ',A,'-TYPE SUB-SUBSECTIONS',18X,':',I5)
   86 FORMAT (1X,127('-'))
   87 FORMAT (1X,53('-'),' END SUB-SECTION:',I3,1X,53('-'))
   91 FORMAT (////1X,52('-'),' RESPONSE CALCULATIONS ',52('-')//
     1   5X,'GROUP-NUMBER',5X,'ENERGY-BOUNDARIES (eV)',10X,
     2   'RESPONSE (Bq)'/)
   92 FORMAT (I12,1P,E17.3,' - ',1P,E10.3,1P,D22.3)
   93 FORMAT (/1X,1P,E28.3,' - ',1P,E10.3,1P,D22.3)
      END
      SUBROUTINE SECMAP(IP33,NROFNC)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE GENERATES A MAP OF THE SUB-SUBSECTIONS OF THE
C     ENDF-6 FILE MF=33
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C
C     * * * * * * * * * * * * * W A R N I N G * * * * * * * * * * * *
C
C     THE VERSION JAN 29, 1991 OF THE IRDF90G LIBRARY DOES NOT CONTAIN
C     CROSS SECTIONS HAVING NC-TYPE SUB-SUBSECTIONS, THEREFORE THIS
C     PART OF THE PROGRAM COULD NOT BE TESTED
C
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
      REAL ANIS,C,COVLST,GEOLST,XMFS,XMT
      INTEGER I,ICI,ICI1,ICI2,IP33,J,LTY,LUKREF,MAT,MATLST,MATS,MFS,MR,
     1   MTLIST,MTS,NC,NCI,NDETEC,NEI,NL,NPNP,NPOI,NRNC,NROFNC,NRREC
      COMMON /SUBSUB/ NPNP,NPOI(3,NSSMAX)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      DIMENSION C(3),XMT(3)
      SAVE
      NRNC=0
      MR=NRREC(2,IP33)
    1 READ (3,80,REC=MR) NL,MAT
      MR=MR+1
      DO 20 I=1,NL
      READ (3,81,REC=MR) NC
      IF (NC.EQ.0) GO TO 30
      MR=MR+1
      DO 10 J=1,NC
      READ (3,82,REC=MR) LTY
      MR=MR+1
      IF (LTY.EQ.0) THEN
         READ (3,80,REC=MR) NCI
         MR=MR+1
         ICI1=1
    5    ICI2=ICI1+2
         IF (ICI2.GT.NCI) ICI2=NCI
         READ (3,80,REC=MR) (C(ICI),XMT(ICI),ICI=ICI1,ICI2)
         MR=MR+1
         DO 6 ICI=ICI1,ICI2
         NRNC=NRNC+1
         IF (NRNC.GT.NSSMAX) THEN
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
         NPOI(1,NRNC)=MAT
         NPOI(2,NRNC)=NINT(XMT(ICI))
         NPOI(3,NRNC)=LUKREF(MAT,33,NPOI(2,NRNC))
    6    CONTINUE
         IF (ICI2.NE.NCI) THEN
            ICI1=ICI1+3
            GO TO 5
         END IF
      ELSE
         READ (3,83,REC=MR) MATS,MTS,NEI
         MR=MR+1
         READ (3,80,REC=MR) XMFS
         MR=MR+1+NEI/3
         MFS=NINT(XMFS)
         NRNC=NRNC+1
         IF (NRNC.GT.NSSMAX) THEN
            CALL ERRLOG(54)
            CALL ERXPLN(54)
         END IF
         NPOI(1,NRNC)=MATS
         NPOI(2,NRNC)=MTS
         NPOI(3,NRNC)=LUKREF(MATS,MFS,MTS)
      END IF
   10 CONTINUE
   20 CONTINUE
   30 CONTINUE
      NROFNC=NRNC
      RETURN
   80 FORMAT (55X,I11,I4)
   81 FORMAT (44X,I11)
   82 FORMAT (33X,I11)
   83 FORMAT (22X,2I11,11X,I11)
      END
      SUBROUTINE STRUC(IN,LBFLG,ILO,IPO,IRESP)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE UNCERTAINTY CONTRIBUTION OF THE
C     INI-TH NI-TYPE SUB-SUBSECTION OF THE ENDF-6 FILE MF=33
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION WKSUM,WLSUM,SUMCOV,REUSER,FLUSER,ADDCOV
C***** DOUBLE *****
C***** SINGLE *****
C     REAL WKSUM,WLSUM,SUMCOV,REUSER,FLUSER,ADDCOV
C***** SINGLE *****
      REAL ANII,ANIJ,ANIS,CFIJN,CMUSER,COVLST,CRUSER,CRUSR0,CRUSRI,
     1   CRUSRJ,E1,E2,EENDF,EKHIGH,EKLOW,ELHIGH,ELLOW,EMAX,EMIN,ESAND,
     2   EUSER,FLSAND,FRACE,G1I,G1J,G2I,G2J,G3I,G3J,G4I,G4J,GEOLST,TMP,
     3   WEI,WI,WJ
      INTEGER I,II,ILO,ILOW,IN,INI,IPO,IPOINT,IRESP,J,JJ,JLOW,JPOINT,
     1   JRESP,K,KOVFLG,L,LB,LBFLG,LTY,M,MATI,MATJ,MATLST,MTI,MTJ,
     2   MTLIST,MGENDF,N,N1,NDBLK,NDETEC,NEC,NEC1,NER,NER1,NFIRST,
     3   NGENDF,NGUSER,NOTUSD,NRC,NRREC
      LOGICAL MAIGAT,NONE
      CHARACTER*8 FOLNAM,FOI,FOJ
      CHARACTER*2 COVNAM,COI,COJ
      COMMON /CENDF/ E1,E2,EENDF(641),CFIJN(NGEMAX,NGEMAX),LTY,
     1   NGENDF,MGENDF
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WJ(641)
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      DIMENSION IRESP(*),JRESP(3),CRUSR0(NGUMAX),CRUSRI(NGUMAX),
     1   CRUSRJ(NGUMAX)
      EQUIVALENCE (CRUSER(1),CRUSRI(1))
      SAVE
      MAIGAT=.TRUE.
      IPOINT=IPO
      JPOINT=IPO
      NER=0
      INI=IN
      LB=LBFLG
      IF (LB.EQ.8) THEN
         CALL LUKSXS(2,IPOINT,0,N1,.FALSE.)
         READ (9)
         READ (9) N1,(CRUSR0(I),I=1,NGUSER)
      END IF
      IF (INI.EQ.1) THEN
         CALL RESAND(E1,E2,2,IPOINT,NFIRST,IRESP)
         CALL COARXS(.FALSE.,NFIRST,ILOW,1)
         JLOW=ILOW
         ILO=ILOW
      END IF
      DO 10 I=1,640
      WJ(I)=WI(I)
   10 CONTINUE
      DO 20 J=1,NGUSER
      CRUSRJ(J)=CRUSER(J)
   20 CONTINUE
   99 CONTINUE
C     DO 100 I=ILOW,IHIGH
      I=ILOW
11111 IF (I.GT.NGUSER) GO TO 11112
      CALL WRKING
C     DO 100 J=ILOW,IHIGH
      J=JLOW
22222 IF (J.GT.NGUSER) GO TO 22223
      DO 103 K=1,NGENDF
      IF (EENDF(K+1).LE.EUSER(I)) GO TO 103
      IF (EENDF(K).GE.EUSER(I+1)) GO TO 101
      EKLOW=AMAX1(EENDF(K),EUSER(I))
      EKHIGH=AMIN1(EENDF(K+1),EUSER(I+1))
      WKSUM=0.D0
      DO 102 M=NFIRST,640
      IF (ESAND(M+1).LE.EKLOW) GO TO 102
      IF (ESAND(M).GE.EKHIGH) GO TO 104
      EMIN=AMAX1(EKLOW,ESAND(M))
      EMAX=AMIN1(EKHIGH,ESAND(M+1))
      FRACE=(EMAX-EMIN)/(ESAND(M+1)-ESAND(M))
      WKSUM=WKSUM+DPROD(FRACE,WI(M))
  102 CONTINUE
  104 CONTINUE
      SUMCOV=0.D0
      DO 203 L=1,MGENDF
      IF (EENDF(NER+L+1).LE.EUSER(J)) GO TO 203
      IF (EENDF(NER+L).GE.EUSER(J+1)) GO TO 204
      ELLOW=AMAX1(EENDF(NER+L),EUSER(J))
      ELHIGH=AMIN1(EENDF(NER+L+1),EUSER(J+1))
      WLSUM=0.D0
      DO 205 N=NFIRST,640
      IF (ESAND(N+1).LE.ELLOW) GO TO 205
      IF (ESAND(N).GE.ELHIGH) GO TO 206
      EMIN=AMAX1(ELLOW,ESAND(N))
      EMAX=AMIN1(ELHIGH,ESAND(N+1))
      FRACE=(EMAX-EMIN)/(ESAND(N+1)-ESAND(N))
      WLSUM=WLSUM+DPROD(FRACE,WJ(N))
  205 CONTINUE
  206 CONTINUE
      IF (LB.EQ.8) THEN
         IF (K.EQ.L)
     1   SUMCOV=SUMCOV+WLSUM*DBLE(CFIJN(K,L))*DBLE((EENDF(K+1)-EENDF(K))
     2   /(ELHIGH-ELLOW))
      ELSE
         SUMCOV=SUMCOV+WLSUM*DBLE(CFIJN(K,L))
      END IF
  203 CONTINUE
  204 IF (REUSER(I).NE.0.D0.AND.REUSER(J).NE.0.D0) THEN
         ADDCOV=(SUMCOV*WKSUM)/(REUSER(I)*REUSER(J))
         IF (LB.GE.1.AND.LB.LE.6) THEN
            CMUSER(I,J)=CMUSER(I,J)+ADDCOV
         ELSE IF (LB.EQ.8) THEN
            IF (I.EQ.J)
     1      CMUSER(I,J)=CMUSER(I,J)+ADDCOV/(CRUSR0(I)*CRUSR0(J))
         ELSE
            CMUSER(I,J)=CMUSER(I,J)+ADDCOV/(CRUSRI(I)*CRUSRJ(J))
         END IF
      END IF
  103 CONTINUE
  101 CONTINUE
      J=J+1
      GO TO 22222
22223 CONTINUE
      I=I+1
      GO TO 11111
11112 CONTINUE
      IF (MAIGAT) RETURN
      GO TO 400
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY STRUC6(II,JJ,NER1,NEC1)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CALCULATES THE CROSS-COVARIANCE MATRIX OF THE
C     II-TH AND JJ-TH ELEMENTS OF THE USER'S REQUEST LIST DUE TO THE
C     LB=6 SUB-SUB-SECTIONS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      MAIGAT=.FALSE.
      LB=6
      DO 1300 I=1,NGUSER
      DO 300 J=1,NGUSER
      CMUSER(I,J)=0.
  300 CONTINUE
 1300 CONTINUE
C-=-=-
C     REACTION UNDER PROCESSING
C-=-=-
      IPOINT=II
      NER=NER1+1
      NGENDF=NER
      FOI=FOLNAM(IPOINT)
      G1I=GEOLST(1,IPOINT)
      G2I=GEOLST(2,IPOINT)
      COI=COVNAM(IPOINT)
      G3I=COVLST(1,IPOINT)
      G4I=COVLST(2,IPOINT)
      ANII=ANIS(IPOINT)
      MATI=MATLST(IPOINT)
      MTI=MTLIST(IPOINT)
      DO 310 I=1,640
      WJ(I)=WI(I)
  310 CONTINUE
C-=-=-
C     REFERRED REACTION
C-=-=-
      JPOINT=JJ
      NEC=NEC1+1
      MGENDF=NEC
      CALL RESAND(E1,E2,2,JPOINT,NFIRST,JRESP)
      CALL LUKXSL(JPOINT,NONE,NRC)
      READ (4,REC=NRC) FOJ,G1J,G2J,COJ,G3J,G4J,ANIJ,
     1      MATJ,MTJ,JLOW,KOVFLG
      NRC=NRC+1
      READ (4,REC=NRC) (CRUSRJ(J),J=JLOW,NGUSER)
      DO 320 I=1,640
      TMP=WJ(J)
      WJ(I)=WI(I)
      WI(I)=TMP
  320 CONTINUE
      IF (ILOW.LT.JLOW) THEN
         DO 330 J=ILOW,JLOW-1
         CRUSRJ(J)=0.
  330    CONTINUE
         JLOW=ILOW
      END IF
      IF (JLOW.LT.ILOW) THEN
         DO 340 I=JLOW,ILOW-1
         CRUSRI(I)=0.
  340    CONTINUE
         ILOW=JLOW
      END IF
      GO TO 99
C-=-=-
  400 CONTINUE
      KOVFLG=2
      READ (4,REC=4) NDBLK,NOTUSD
      NRC=NOTUSD
      WRITE (4,REC=NRC) FOI,G1I,G2I,COI,G3I,G4I,ANII,
     1      MATI,MTI,ILOW,KOVFLG
      NRC=NRC+1
      WEI=1.
      WRITE (4,REC=NRC) FOJ,G1J,G2J,COJ,G3J,G4J,MATJ,MTJ,WEI
      NRC=NRC+1
      DO 410 I=ILOW,NGUSER
      WRITE (4,REC=NRC+I-ILOW) (CMUSER(I,J),J=ILOW,NGUSER)
  410 CONTINUE
      NDBLK=NDBLK+1
      NOTUSD=NRC+NGUSER-ILOW+1
      WRITE (4,REC=4) NDBLK,NOTUSD
      RETURN
      END
      SUBROUTINE WXSLWC(IPOINT,NFIRST,N1STU)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
C     WRITE THE CROSS SECTIONS INTO THE XSL LIBRARY WITHOUT COVARIANCES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL ANIS,CMUSER,COVLS1,COVLS2,COVLST,CRUSER,E,E1,E2,EUSER,FFIJN,
     1   GEOLST,GEOMT1,GEOMT2
      INTEGER I,IPOINT,IRESP,J,KOVFLG,LTY,MAT,MATLST,MP,MT,MTLIST,N1STU,
     1   NDBLK,NDETEC,NFIRST,NGUSER,NOTUSD,NP,NRC,NRREC
      CHARACTER*8 FOLNAM
      CHARACTER*2 COVNAM
      CHARACTER*1 EQAT
      COMMON /CENDF/ E1,E2,E(641),FFIJN(NGEMAX,NGEMAX),LTY,NP,MP
      COMMON /DETECT/ NDETEC,MATLST(0:NDETMX),MTLIST(0:NDETMX),
     1   GEOLST(2,0:NDETMX),COVLST(2,0:NDETMX),ANIS(0:NDETMX),
     2   NRREC(3,0:NDETMX)
      COMMON /DETECH/ FOLNAM(0:NDETMX),COVNAM(0:NDETMX)
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      DIMENSION IRESP(5)
      CALL RESAND(E1,E2,3,IPOINT,NFIRST,IRESP)
      WRITE (6,81)
      GEOMT1=GEOLST(1,IPOINT)
      IF (GEOMT1.GE.0) THEN
         EQAT='='
      ELSE
         EQAT='@'
         GEOMT1=-GEOMT1
      END IF
      WRITE (6,87) FOLNAM(IPOINT),EQAT,GEOMT1,
     1   GEOLST(2,IPOINT),COVNAM(IPOINT),COVLST(1,IPOINT),
     2   COVLST(2,IPOINT),ANIS(IPOINT)
      CALL RESANL(IRESP)
      CALL COARXS(.TRUE.,NFIRST,I,1)
      DO 10 N1STU=1,NGUSER
      IF (CRUSER(N1STU).GT.0.) GO TO 11
   10 CONTINUE
   11 READ (4,REC=4) NDBLK,NOTUSD
      NRC=NOTUSD
      MAT=MATLST(IPOINT)
      MT=MTLIST(IPOINT)
      GEOMT1=GEOLST(1,IPOINT)
      GEOMT2=GEOLST(2,IPOINT)
      COVLS1=COVLST(1,IPOINT)
      COVLS2=COVLST(2,IPOINT)
      KOVFLG=0
      WRITE (4,REC=NRC) FOLNAM(IPOINT),GEOMT1,GEOMT2,
     1   COVNAM(IPOINT),COVLS1,COVLS2,ANIS(IPOINT),MAT,MT,
     2   N1STU,KOVFLG
      NRC=NRC+1
      WRITE (4,REC=NRC) (CRUSER(J),J=N1STU,NGUSER)
      NDBLK=NDBLK+1
      NOTUSD=NRC+1
      WRITE (4,REC=4) NDBLK,NOTUSD
      RETURN
   81 FORMAT (' ')
   87 FORMAT (////1X,127('=')/
     1   ' EVALUATED CROSS SECTION OF THE DETECTOR:  ',A8,2X,A1,
     2   1P,2E11.3,2X,A2,1P,2E11.3,0P,F7.1/1X,127('='))
      END
      SUBROUTINE XSLIST
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE READS THE CROSS SECTION LIBRARY IN THE USER'S
C     (COARSE) GROUP STRUCTURE AND LISTS THE DETECTOR IDENTIFIERS
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'X333PARM.FOR'
C***** DOUBLE *****
      DOUBLE PRECISION REUSER,FLUSER
C***** DOUBLE *****
C***** SINGLE *****
C     REAL REUSER,FLUSER
C***** SINGLE *****
      REAL ANIS,CMUSER,CRUSER,EUSER,G1,G2,G3,G4,WEI
      INTEGER I,I1,I2,KOVFLG,LR,MAT,MT,N,N1STU,NDBLK,
     1   NGUSE1,NGUSER,NOFUSD,NOTUSD,NRC
      CHARACTER*80 TITCRD
      CHARACTER*8 NAM
      CHARACTER*2 COV
      CHARACTER*1 EQAT
      COMMON /CUSER/ NGUSER,CMUSER(NGUMAX,NGUMAX),EUSER(NGUMX1),
     1   REUSER(NGUMAX),CRUSER(NGUMAX),FLUSER(NGUMAX)
      SAVE
      NGUSE1=NGUSER+1
      LR=MAX(NGUSE1*4,54)
      IF (NGUSE1*4.GT.80) THEN
         READ (4,REC=2) TITCRD
      ELSE
         READ (4,REC=2) TITCRD(1:LR)
      END IF
      WRITE (6,80) NGUSER,TITCRD
      READ (4,REC=3) (EUSER(I),I=1,NGUSE1)
      I1=1
    1 I2=I1+11
      IF (I2.GT.NGUSE1) I2=NGUSE1
      WRITE (6,81) I1,(EUSER(I),I=I1,I2)
      IF (I2.EQ.NGUSE1) GO TO 2
      I1=I1+12
      GO TO 1
    2 READ (4,REC=4) NDBLK,NOTUSD
      NOFUSD=NOTUSD-1
      WRITE (6,82) NDBLK,NOFUSD,LR
      NRC=5
      DO 20 N=1,NDBLK
      READ (4,REC=NRC) NAM,G1,G2,COV,G3,G4,ANIS,MAT,MT,N1STU,KOVFLG
      NRC=NRC+1
      IF (G1.GE.0) THEN
         EQAT='='
      ELSE
         EQAT='@'
         G1=-G1
      END IF
      WRITE (6,83) N,NAM,MAT,MT,EQAT,G1,G2,COV,G3,G4,ANIS,N1STU,KOVFLG
      WEI=0.
      IF (KOVFLG.EQ.0) THEN
         NRC=NRC+1
      ELSE IF (KOVFLG.EQ.1) THEN
         NRC=NRC+NGUSER-N1STU+2
      ELSE
         READ (4,REC=NRC) NAM,G1,G2,COV,G3,G4,MAT,MT,WEI
         NRC=NRC+1
         IF (WEI.EQ.1.) NRC=NRC+NGUSER-N1STU+1
         IF (G1.GE.0) THEN
            EQAT='='
         ELSE
            EQAT='@'
            G1=-G1
         END IF
         WRITE (6,84) NAM,MAT,MT,EQAT,G1,G2,COV,G3,G4
      END IF
   20 CONTINUE
      WRITE (6,85)
      RETURN
   80 FORMAT (' '//1X,127('=')/' THE CONTENTS OF THE USER''S CROSS',
     1   ' SECTION LIBRARY IN',I3,' GROUPS'/1X,127('=')///
     2   ' DESCRIPTION: "',A,'"'///' ENERGY GRID (UNIT = MeV):'/)
   81 FORMAT (I4,':  ',1P,12E10.3)
   82 FORMAT (//' NUMBER OF CROSS SECTION DATA BLOCKS:',I7/
     1   ' NUMBER OF DATA RECORDS IN THE LIBRARY:',I5/
     2   ' RECORD LENGTH (BYTES):',I21///1X,127('=')/
     3   '  BLOCK ',15('-'),' DETECTOR ',15('-'),1X,8('-'),' COVER ',
     4   9('-'),' ANISO- FIRST COV. DATA'/
     5   '   No   NAME      MAT  MT  ----- GEOMETRY ------ NAME ',
     6   '----- GEOMETRY ---- TROPY  GROUP AVAILABLE'/1X,127('=')/)
   83 FORMAT (I5,3X,A8,I5,I4,2X,A1,1P,2E10.3,2X,A2,1X,1P,2E10.3,0P,F8.2,
     1   I5,I7)
   84 FORMAT (8X,A8,I5,I4,2X,A1,1P,2E10.3,2X,A2,1X,1P,2E10.3,
     1   22X,'(REFERRED DETECTOR)')
   85 FORMAT (/1X,127('=')/)
      END
      SUBROUTINE XSP640(ARR,NF,NL,MAT0,MT0,IZ0,IA0,IH0,NM,GEA,CN,CT)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PRINTS THE CROSS SECTIONS IN THE 640 GROUP
C     SAND II STRUCTURE
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      REAL AGE,ARR,CT,ESAND,FLSAND,GEA,WI,WORKS
      INTEGER I,IA,IA0,IA2,IH,IH0,II,IZ,IZ0,IZ2,J,MAT,MAT0,MAT2,
     1   MT,MT0,MT2,NF,NL
      LOGICAL ONLY
      CHARACTER*(*) NM,CN
      CHARACTER*8 EIGTBL
      CHARACTER*3 RC3,CATW
      CHARACTER*2 CIZ
      CHARACTER*1 CGEO
      COMMON /CSAND/ ESAND(641),FLSAND(640),WI(640),WORKS(641)
      DIMENSION ARR(*),GEA(*),CT(*)
      SAVE
      DATA EIGTBL /'        '/
      ONLY=.FALSE.
      MAT=MAT0
      MT=MT0
      CALL RCTION(MT,RC3)
      IZ=IZ0
      CALL CHESYM(2,CIZ,IZ)
      IA=IA0
      CALL IAFORM(IA,CATW)
      IH=IH0
      IF (IH.EQ.1) GO TO 10
      IF (IH.GT.1) GO TO 13
      WRITE (6,14)
    2 WRITE (6,16) MAT,IZ,CIZ,IA,CATW,MT,RC3
      IF (ONLY) THEN
         WRITE (6,21)
         RETURN
      ELSE
         WRITE (6,22)
      END IF
      IF (NM.EQ.EIGTBL) THEN
         WRITE (6,17) CN
      ELSE
         WRITE (6,17) NM
      END IF
    3 IF (NF.NE.1) WRITE (6,5) ESAND(NF)
      DO 4 I=NF,NL,12
      II=I+11
      IF (II.GT.NL) II=NL
      WRITE (6,6) I,(ARR(J),J=I,II)
    4 CONTINUE
      RETURN
    5 FORMAT (' THRESHOLD ENERGY:',1P,E10.3,' eV')
    6 FORMAT (I5,':  ',1P,12E10.3)
   10 WRITE (6,15)
      WRITE (6,16) MAT,IZ,CIZ,IA,CATW,MT,RC3
      IF (ONLY) THEN
         WRITE (6,21)
         RETURN
      ELSE
         WRITE (6,22)
      END IF
      IF (NM.EQ.EIGTBL) THEN
         WRITE (6,18) CN,CT(1),CT(2)
      ELSE
         CGEO='='
         AGE=ABS(GEA(1))
         IF (AGE.NE.GEA(1)) CGEO='@'
         WRITE (6,19) NM,CGEO,AGE,GEA(2)
      END IF
      GO TO 3
   13 WRITE (6,15)
      WRITE (6,16) MAT,IZ,CIZ,IA,CATW,MT,RC3
      WRITE (6,22)
      CGEO='='
      AGE=ABS(GEA(1))
      IF (AGE.NE.GEA(1)) CGEO='@'
      WRITE (6,20) NM,CGEO,AGE,GEA(2),CN,CT(1),CT(2)
      GO TO 3
   14 FORMAT (' '//1X,57('='),' LIBRARY DATA ',56('='))
   15 FORMAT (' '//1X,55('='),' CALCULATED DATA ',55('='))
   16 FORMAT (' MAT:',I59/' Z:',I61,4X,A/
     2   ' A:',I61,4X,A/' MT:',I60,4X,'(N,',A)
   17 FORMAT (' CROSS SECTIONS IN THE SAND II STRUCTURE: ',
     1   A/1X,127('='))
   18 FORMAT (' COVER ATTENUATION FACTORS IN THE SAND II STRUCTURE: ',
     1   A,1P,2E10.3/1X,127('='))
   19 FORMAT (' SELF-SHIELDED XSEC-S IN THE SAND II STRUCTURE:   ',
     1   A,2X,A,1P,2E10.3/1X,127('='))
   20 FORMAT (' SELF- AND COVER-SHIELDED XSEC-S IN THE SAND II',
     1   ' STRUCTURE:',3X,A,2X,A,1P,2E10.3,2X,A,1P,2E10.3/
     2   1X,127('='))
   21 FORMAT (1X,127('='))
   22 FORMAT (1X,127('-'))
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ENTRY XSCLOG(MAT2,MT2,IZ2,IA2)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE PRINTS THE CROSS SECTION COVARIANCE
C     CALCULATION LOG
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      ONLY=.TRUE.
      MAT=MAT2
      MT=MT2
      CALL RCTION(MT,RC3)
      IZ=IZ2
      CALL CHESYM(2,CIZ,IZ)
      IA=IA2
      CALL IAFORM(IA,CATW)
      WRITE (6,30)
      GO TO 2
   30 FORMAT (' '//1X,38('='),
     1   ' PROCESSING OF THE COVARIANCE FILE OF THE LIBRARY ',39('='))
      END
