      PROGRAM XSLXOUT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C
C     THIS PROGRAM CALCULATES THE RESPONSE VALUES FOR ALL THE POSSIBLE
C     COMBINATIONS OF THE CROSS SECTIONS IN THE LIBRARY TASKNAME.XSL
C     AND THE SPECTRA IN THE TASKNAME.OUT FILE
C
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      REAL ANIS,DRIN,DRNOR,DROUT,G1,G2,G3,G4,RIN,RNOR,ROUT,SIC,SIN,SNC,
     1   SNOR,SOC,SOUT,XS,XSC
      INTEGER I,IER,KOVFLG,MAT,MT,NGLIB,NRC,NXS
      CHARACTER*72 TITS,TITX
      CHARACTER*8 NAME
      CHARACTER*2 COVER
      CHARACTER*1 EQAT
      DIMENSION SIN(NGMAX),SNOR(NGMAX),SOUT(NGMAX),XS(NGMAX),
     1   XSC(NGMAX,NGMAX),SIC(NGMAX,NGMAX),SNC(NGMAX,NGMAX),
     2   SOC(NGMAX,NGMAX)
      CALL CNCTIO(NGLIB,IER)
      IF (IER.GT.0) STOP 1
      CALL OUTCPY(NGLIB,TITS,SIN,SIC,SNOR,SNC,SOUT,SOC,IER)
      IF (IER.GT.0) STOP 2
      READ (4,REC=2) TITX
      READ (4,REC=4) NXS
      WRITE (6,11) TITX,TITS
      NRC=5
      DO 1 I=1,NXS
         CALL ONEBLK(NGLIB,NRC,NAME,G1,G2,COVER,G3,G4,ANIS,
     1   MAT,MT,KOVFLG,XS,XSC)
         IF (KOVFLG.GT.1) GO TO 1
         IF (G1.LT.0.) THEN
            EQAT='@'
            G1=-G1
         ELSE
            EQAT='='
         END IF
         CALL RESPONSE(NGLIB,XS,KOVFLG,XSC,SIN,SIC,RIN,DRIN)
         CALL RESPONSE(NGLIB,XS,KOVFLG,XSC,SNOR,SNC,RNOR,DRNOR)
         CALL RESPONSE(NGLIB,XS,KOVFLG,XSC,SOUT,SOC,ROUT,DROUT)
         WRITE (6,12) NAME,EQAT,G1,G2,COVER,G3,G4,ANIS,MAT,MT,
     1   RIN,DRIN,RNOR,DRNOR,ROUT,DROUT
    1 CONTINUE
      STOP
   11 FORMAT ('1'/2(1X,A/)/
     1   8X,'DETECTOR',22X,'COVER',17X,'ANIS   MAT MT',21X,'RESPONSES'/
     2   2(' NAME',10X,'GEOMETRY',8X),13X,'INPUT',6X,' %  ',
     3   'NORMALIZED  %  OUTPUT',5X,' %'/)
   12 FORMAT (1X,A,2X,A,1P,2E10.3,1X,A,1P,2E10.3,0P,F10.3,I5,I4,
     1   3(1P,E10.3,0P,F6.2))
      END
      SUBROUTINE CNCTIO(NGLIB,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THIS SUBROUTINE CONNECTS THE I/O FILES TO THE LOGICAL UNITS
C     UNIT #0:  STANDARD ERROR OUTPUT
C     UNIT #4:  PROBLEM-DEPENDENT X-SECTION LIBRARY
C     UNIT #5:  STANDARD INPUT
C     UNIT #6:  STANDARD OUTPUT
C     UNIT #7:  OUTPUT OT THE STAYNL
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      CHARACTER*72 TSKNAM,FILSP,FIL4,FIL6,FIL7
      CHARACTER*3 CHNGUS
      CHARACTER*1 CHNGI,O
      INTEGER I,IER,L,LFIL,LR,LTSKN,NGLIB
      LOGICAL EX,EY
    1 FORMAT (A)
C***** IBM PC/AT *****
    2 FORMAT (/1X,A/' IS NOT IN THE CURRENT DIRECTORY.')
    3 FORMAT (/1X,A/' EXISTS IN THE CURRENT DIRECTORY.')
    4 FORMAT (' TYPE THE FILE-SPEC',
     1        ' ([DRIVE:][PATH]FILENAME.EXTENSION):'/)
    5 FORMAT (/' TYPE [DRIVE:][PATH\] FOR THE SCRATCH FILES:'/)
C***** IBM PC/AT *****
   10 WRITE (0,11)
   11 FORMAT (/' NAME OF THE TASK: ')
      READ (5,1) TSKNAM
      CALL LASTCH(TSKNAM,LTSKN)
      IF (LTSKN.EQ.0) GO TO 10
      FIL4=TSKNAM(1:LTSKN)//'.XSL'
      L=LTSKN+4
      INQUIRE (FILE=FIL4,EXIST=EX)
      IF (.NOT.EX) THEN
   13    WRITE (0,2) FIL4(1:L)
         WRITE (0,4)
         READ (5,1) FILSP
         FIL4=FILSP
         CALL LASTCH(FIL4,LFIL)
         IF (LFIL.EQ.0) GO TO 13
         INQUIRE(FILE=FIL4,EXIST=EY)
         IF (.NOT.EY) GO TO 30
      END IF
      FIL7=TSKNAM(1:LTSKN)//'.OUT'
      INQUIRE (FILE=FIL7,EXIST=EX)
      IF (.NOT.EX) THEN
   16    WRITE (0,2) FIL7(1:L)
         WRITE (0,4)
         READ (5,1) FILSP
         FIL7=FILSP
         CALL LASTCH(FIL7,LFIL)
         IF (LFIL.EQ.0) GO TO 16
         INQUIRE(FILE=FIL7,EXIST=EY)
         IF (.NOT.EY) GO TO 30
      END IF
   20 WRITE (0,21)
   21 FORMAT (/' SELECT THE STANDARD OUTPUT {S|P|D}:'/
     1  ' ENTER "S" FOR THE SCREEN'/
     2  ' ENTER "P" FOR THE PRINTER'/
     3  ' ENTER "D" FOR THE DISK FILE taskname.RSP'/)
   22 FORMAT (' DO YOU WANT TO DELETE IT? {Y|N}')
      READ (5,1) O
      IF (O.EQ.'P' .OR. O.EQ.'p') THEN
         OPEN (UNIT=6,FILE='PRN')
         WRITE (0,*)
     1      'PUT WIDE PAPER INTO PRINTER OR SET "CONDENSED" MODE'
         WRITE (0,*) 'HIT ENTER WHEN READY'
         READ (5,*)
      ELSE IF (O.EQ.'D' .OR. O.EQ.'d') THEN
         FIL6=TSKNAM(1:LTSKN)//'.RSP'
         INQUIRE (FILE=FIL6,EXIST=EX)
         IF (EX) THEN
   24       WRITE (0,3) FIL6(1:L)
   25       WRITE (0,22)
            READ (5,1) O
            IF (O.EQ.'N' .OR. O.EQ.'n') THEN
               WRITE (0,4)
               READ (5,1) FILSP
               FIL6=FILSP
               CALL LASTCH(FIL6,LFIL)
               IF (LFIL.EQ.0) GO TO 24
               INQUIRE(FILE=FIL6,EXIST=EY)
               IF (EY) GO TO 32
               OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
            ELSE IF (O.EQ.'Y' .OR. O.EQ.'y') THEN
               OPEN (UNIT=6,FILE=FIL6,STATUS='OLD')
            ELSE
               GO TO 25
            END IF
         ELSE
            OPEN (UNIT=6,FILE=FIL6,STATUS='NEW')
         END IF
      ELSE IF (O.NE.'S'.AND.O.NE.'s') THEN
         GO TO 20
      END IF
      OPEN (UNIT=4,FILE=FIL4,STATUS='OLD',ACCESS='DIRECT',
     1   FORM='UNFORMATTED',RECL=1)
      DO 27 I=1,3
      READ (4,REC=I) CHNGI
      CHNGUS(I:I)=CHNGI
   27 CONTINUE
      READ (CHNGUS,34) NGLIB
      CLOSE (UNIT=4,STATUS='KEEP')
      LR=MAX((NGLIB+1)*4,54)
      OPEN (UNIT=4,FILE=FIL4,STATUS='OLD',ACCESS='DIRECT',
     1   RECL=LR,FORM='UNFORMATTED')
      OPEN (UNIT=7,FILE=FIL7,STATUS='OLD',FORM='FORMATTED')
      RETURN
   30 IER=5
      WRITE (0,31) FILSP(1:L)
   31 FORMAT (/1X,A/' DOES NOT EXIST.'//'SORRY.'//)
      RETURN
   32 IER=5
      WRITE (0,33) FILSP(1:L)
   33 FORMAT (/1X,A/' ALREADY EXISTS.'//'SORRY.'//)
      RETURN
   34 FORMAT (I3)
      END
      SUBROUTINE OUTCPY(NGLIB,TITLE,SIN,SIC,SNOR,SNC,SOUT,SOC,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      REAL SIC,SIN,SNC,SNOR,SOC,SOUT
      INTEGER IER,NGLIB,NGUSER
      CHARACTER*72 TITLE
      CHARACTER*8 PHASE
      DIMENSION SIN(NGMAX),SNOR(NGMAX),SOUT(NGMAX),
     1   SIC(NGMAX,NGMAX),SNC(NGMAX,NGMAX),SOC(NGMAX,NGMAX)
      IER=0
      READ (7,2) TITLE
    1 READ (7,3) PHASE
      IF (PHASE.NE.' INPUT  ') GO TO 1
    2 FORMAT (A)
    3 FORMAT (72X,A)
      READ (7,*) NGUSER
      IER=ABS(NGUSER-NGLIB)
      IF (IER.NE.0) RETURN
      CALL READER(SIN,SIC,NGUSER)
    5 READ (7,3) PHASE
      IF (PHASE.NE.' NORM-D ') GO TO 5
      READ (7,*)
      CALL READER(SNOR,SNC,NGUSER)
    7 READ (7,3) PHASE
      IF (PHASE.NE.' OUTPUT ') GO TO 7
      READ (7,*)
      CALL READER(SOUT,SOC,NGUSER)
      RETURN
      END
      SUBROUTINE ONEBLK(NGUSER,NRE,NAME1,G11,G21,COVER1,G31,G41,ANIS1,
     1   MAT,MT,KOVFLG,XS,XSC)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     READ ONE BLOCK FROM THE USER'S CROSS SECTION LIBRARY
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      INTEGER I,J,KOV,KOVFLG,MAT,MT,N1STU,NGU,NGUSER,NRE,NRC
      REAL ANIS,ANIS1,G11,G21,G31,G41,Q1,Q2,Q3,Q4,W,
     1   WRK,XS,XSC
      CHARACTER*8 NAME,NAME1
      CHARACTER*2 COVER,COVER1
      DIMENSION XS(NGUSER),XSC(NGMAX,NGMAX),WRK(NGMAX)
      NRC=NRE
      NGU=NGUSER
      READ (4,REC=NRC) NAME,Q1,Q2,COVER,Q3,Q4,ANIS,
     1   MAT,MT,N1STU,KOV
      NAME1=NAME
      G11=Q1
      G21=Q2
      COVER1=COVER
      G31=Q3
      G41=Q4
      ANIS1=ANIS
      KOVFLG=KOV
      NRC=NRC+1
      DO 10 I=1,NGU
         WRK(I)=0.
   10 CONTINUE
      IF (KOV.LT.2) THEN
         READ (4,REC=NRC) (WRK(J),J=N1STU,NGU)
         NRC=NRC+1
         DO 15 I=1,NGU
            XS(I)=WRK(I)
   15    CONTINUE
      ELSE
         READ (4,REC=NRC) NAME,Q1,Q2,COVER,Q3,Q4,MAT,MT,W
         NRC=NRC+1
      END IF
      IF (KOV.EQ.0) GO TO 40
      DO 25 I=1,N1STU
         DO 20 J=I,NGU
            XSC(I,J)=0.
            XSC(J,I)=0.
   20    CONTINUE
   25 CONTINUE
      DO 35 I=N1STU,NGU
         READ (4,REC=NRC) (WRK(J),J=N1STU,NGU)
         DO 30 J=N1STU,NGU
            XSC(I,J)=XS(I)*WRK(J)*XS(J)
   30    CONTINUE
         NRC=NRC+1
   35 CONTINUE
   40 NRE=NRC
      RETURN
      END
      SUBROUTINE RESPONSE(N,X,K,XC,S,SC,R,DR)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      INTEGER I,J,K,N
      REAL X,XC,S,SC,R,DR
      DOUBLE PRECISION RL,CL,SI
      DIMENSION X(NGMAX),S(NGMAX),XC(NGMAX,NGMAX),SC(NGMAX,NGMAX)
      RL=0.
      DO 1 I=1,N
      SI=S(I)
      RL=X(I)*SI+RL
    1 CONTINUE
      R=RL
      CL=0.
      DO 11 I=1,N
      DO 10 J=1,N
      SI=SC(I,J)
      CL=X(I)*SI*X(J)+CL
      IF (K.GT.0) THEN
         SI=XC(I,J)
         CL=S(I)*SI*S(J)+CL
      END IF
   10 CONTINUE
   11 CONTINUE
      CL=SQRT(CL)
      DR=(2*K-1)*CL/RL*100.
      RETURN
      END
      SUBROUTINE LASTCH(STRING,LNGTH)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     LOOK FOR THE LAST NOT-BLANK CHARACTER IN THE STRING
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      CHARACTER*(*) STRING
      INTEGER I,L,LNGTH
      L=LEN(STRING)
      DO 1 I=L,1,-1
      IF (STRING(I:I).NE.' ') GO TO 2
    1 CONTINUE
      LNGTH=0
      RETURN
    2 LNGTH=I
      RETURN
      END
      SUBROUTINE READER(S,C,N)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'XSL&PARM.FOR'
      REAL C,D,S
      INTEGER I,J,N
      DIMENSION S(NGMAX),D(NGMAX),C(NGMAX,NGMAX)
      READ (7,*)
      READ (7,*) (S(I),I=1,N)
      READ (7,*)
      READ (7,*) (D(I),I=1,N)
      READ (7,*)
      DO 1 I=1,N
      READ (7,*) (C(J,I),J=1,I)
    1 CONTINUE
      DO 4 I=1,N
      DO 3 J=1,I
      C(J,I)=D(J)*S(J)*C(J,I)*S(I)*D(I)*1E-10
    3 CONTINUE
    4 CONTINUE
      DO 6 I=2,N
      DO 5 J=1,I-1
      C(I,J)=C(J,I)
    5 CONTINUE
    6 CONTINUE
      RETURN
      END
