      SUBROUTINE GENNAM(MAT,MT,NAME)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     GENERATE REACTION NAME TO MAT,MT
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'STAYPARM.FOR'
      REAL ANIS,COVLST,GEOLST
      INTEGER I,NDETEC,MAT,MT
      CHARACTER*8 NAME,FOLNAM
      CHARACTER*2 COVNAM
      COMMON /DETECT/ NDETEC,
     1   GEOLST(2,0:NRMAX),COVLST(2,0:NRMAX),ANIS(0:NRMAX)
      COMMON /DETECH/ FOLNAM(0:NRMAX),COVNAM(0:NRMAX)
      WRITE (NAME,15) MAT,MT
   15 FORMAT (I4,'.',I3)
      DO 20 I=1,8
      IF (NAME(I:I).EQ.' ') NAME(I:I)='0'
   20 CONTINUE
      RETURN
      END
      SUBROUTINE NXTWRD(STRING,I1ST,LNGTH)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     LOOK FOR THE NEXT WORD IN THE SUBSTRING STRING(I1ST:80)
C     THE FOUND WORD IS: STRING(N1ST:I1ST+LNGTH-1)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,I1ST,LNGTH
      CHARACTER*80 STRING
      DO 1 I=I1ST,80
      IF (STRING(I:I).NE.' ') GO TO 2
    1 CONTINUE
      LNGTH=0
      RETURN
    2 I1ST=I
      DO 3 I=I1ST,80
      IF (STRING(I:I).EQ.' ') GO TO 4
    3 CONTINUE
      I=81
    4 LNGTH=I-I1ST
      RETURN
      END
      SUBROUTINE UPPCAS(STRING,L)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     CONVERT LOWER CASE LETTERS TO UPPER CASE LETTERS
C     REMOVE THE COMMAS AND APOSTROPHES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INTEGER I,IC,L
      CHARACTER*(*) STRING
      CHARACTER*1 C
      DO 1 I=1,L
      C=STRING(I:I)
      IF (C.EQ.','.OR.C.EQ.'''') THEN
         STRING(I:I)=' '
      ELSE
         IC=ICHAR(C)
         IF (IC.GE.97.AND.IC.LE.122) THEN
            IC=IC-32
            STRING(I:I)=CHAR(IC)
         END IF
      END IF
    1 CONTINUE
      RETURN
      END
      SUBROUTINE XSLCPY(NGUSER,NGUSE1,EUSER,XS,XSC,IER)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     COPY THE PERTINENT BLOCKS OF THE USER'S CROSS SECTION LIBRARY
C     ONTO SCRATCH FILES
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      INCLUDE 'STAYPARM.FOR'
      REAL ANIS,ANIS1,COVLST,EUSER,G11,G12,G21,G22,G31,G32,G41,G42,
     1   GEOLST,ONE,WEI,XS,XSC,ZERO
      INTEGER I,IER,J,KOVFLG,MAT,MT,N,NDBLK,NDETEC,
     1   NGUSER,NGUSE1,NOTUSD,NRC,NUI
      CHARACTER*8 FOLNAM,NAME1,NAME2
      CHARACTER*2 COVER1,COVER2,COVNAM
      LOGICAL LXS
      COMMON /DETECT/ NDETEC,GEOLST(2,0:NRMAX),COVLST(2,0:NRMAX),
     1   ANIS(0:NRMAX)
      COMMON /DETECH/ FOLNAM(0:NRMAX),COVNAM(0:NRMAX)
      DIMENSION EUSER(NGUSE1),XS(NGUSER),XSC(NGUSER,NGUSER)
      DATA ONE,ZERO/1.,0./
      READ (4,REC=3) (EUSER(I),I=1,NGUSE1)
      READ (4,REC=4) NDBLK,NOTUSD
      DO 40 NUI=1,NDETEC
         NRC=5
         DO 30 N=1,NDBLK
            CALL ONEBLK(NGUSER,NRC,NAME1,G11,G21,COVER1,G31,G41,ANIS1,
     1      MAT,MT,KOVFLG,NAME2,G12,G22,COVER2,G32,G42,WEI,XS,XSC)
            LXS=NAME1.EQ.FOLNAM(NUI).AND.G21.EQ.GEOLST(1,NUI).AND.
     1      COVER1.EQ.COVNAM(NUI).AND.G41.EQ.COVLST(1,NUI)
            IF (LXS) THEN
               WRITE (10) XS
               WRITE (9) ONE
               DO 10 I=1,NGUSER
               WRITE (9) (XSC(J,I),J=1,NGUSER)
   10          CONTINUE
               I=NUI+1
               DO 20 J=I,NDETEC
               WRITE (9) ZERO
   20          CONTINUE
               GO TO 40
            END IF
   30    CONTINUE
         IER=MAX(IER,39)
         CALL ERRLOG(39)
         WRITE (6,50) NUI
   40 CONTINUE
   50 FORMAT (' ??? 36 ??? THE CROSS SECTION OF THE',I4,'-THE REACTION',
     1   ' CANNOT BE FOUND IN THE LIBRARY')
      RETURN
      END
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     DOS TIME- ADN DATE-FUNCTION-CALLING SUBROUTINES FOR THE LAHEY
C     F77L-EM/32 VER. 4.01 COMPILER
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
C     THE SUBROUTINE GETTIM AND GETDAT ARE LIBRARY ROUTINES OF THE
C     RYAN-MCFARLAND  AND MICROSOFT COMPILERS, THEREFORE USING THEM
C     COMMENT OUT THE  WHOLE TEXT BELOW (INSERT THE COMMENT SIGN 'C'-S
C     INTO THE FIRST COLUMN OF THE REMAINDER PART OF THE FILE)
C-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
      SUBROUTINE GETTIM(I,J,K,L)
      INTEGER*2 I,J,K,L
      CHARACTER*11 RESULT
      CALL TIME(RESULT)
      READ (RESULT,1) I,J,K,L
      RETURN
    1 FORMAT (3(I2,1X),I2)
      END
      SUBROUTINE GETDAT(I,J,K)
      INTEGER*2 I,J,K
      CHARACTER*8 RESULT
      CALL DATE(RESULT)
      READ (RESULT,1) J,K,I
      I=I+1900
      RETURN
    1 FORMAT (2(I2,1X),I2)
      END
